    //
//  AppDelegate.m
//  TaxControl
//
//  Created by Javier Cava García on 12/10/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//

#import "AppDelegate.h"
#import "Trimestre.h"

@implementation AppDelegate
{
    ClComunes *funcComunes;
}


@synthesize window = _window;
@synthesize managedObjectContext = __managedObjectContext;
@synthesize managedObjectModel = __managedObjectModel;
@synthesize persistentStoreCoordinator = __persistentStoreCoordinator;




- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    // Override point for customization after application launch.
    // Inicialitzacions necessaries
    [self inicialitza];
    
    return YES;
}



// Control importació dades
-(BOOL) application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation
{
    
    if (url != nil && [url isFileURL]) {
    
        [self importa_dades:url];
        
    }
    return YES;
}



// Importacio de dades
-(void)importa_dades:(NSURL *)url
{
    // Importació de dades
    NSError *outError;
    NSString *fileString = [NSString stringWithContentsOfURL:url
                                                   encoding:NSASCIIStringEncoding error:&outError];
    if ( outError != nil)
    {
        [self msg_pantalla:outError.description];
    }

    // Intanciem comunes
    funcComunes = [ClComunes alloc];
    NSManagedObjectContext *lmngObject = [(AppDelegate *)[[UIApplication sharedApplication] delegate] managedObjectContext];
    
    if (fileString != nil) {
        //Depenen del tipus de fitxer carreguem una entita o un altra
        //NSString *str_url =url;
        NSArray *parts = [url.lastPathComponent componentsSeparatedByString:@"/"];
        NSString *filename = [parts objectAtIndex:[parts count]-1];
        // Movem les dades del fitxer a l'array que utilitzarem per carga la BBDD
        NSArray *datafile = [fileString csvRows];
        
        if ( [filename rangeOfString:@"SubCategories"].location != NSNotFound )
        {
            // Carreguem Categories
            [funcComunes importa_Subcategories:datafile:lmngObject];
        }
        else if ( [filename rangeOfString:@"Categories"].location != NSNotFound )
        {
            // Carreguem SubCategories
            [funcComunes importa_categories:datafile:lmngObject];
        }
        else if ( [filename rangeOfString:@"TipusIVA"].location != NSNotFound )
        {
            // Carreguem Tipus d'IVA
            [funcComunes importa_tipusiva:datafile:lmngObject];
        }
        
    }
}


// Inicialitzacions de l'aplicació
-(void) inicialitza
{
    if (__managedObjectContext == nil)
    {
        __managedObjectContext = [(AppDelegate *)[[UIApplication sharedApplication] delegate] managedObjectContext];
        //NSLog(@"After managedObjectContext: %@",  managedObjectContext);
    }

    
    // Intanciem comunes
    funcComunes = [ClComunes alloc];
    
//  Carreguem la taula de trimestres
    [self carrega_trimestres];
    
    
}
// Carrega la taula de trimestres
-(void)carrega_trimestres
{
//    NSFetchRequest *Request;
//    NSEntityDescription *entity;
//    NSArray *seleccion;
//    NSError *error;
    // Inicilitzem el request
    //Request    = [[NSFetchRequest alloc] init];
    // Inicialitzem la entitat
    NSMutableArray *trimestres = [funcComunes set_trimestres:self.managedObjectContext];
    //entity = [NSEntityDescription entityForName:@"Trimestre" inManagedObjectContext:self.managedObjectContext];
    // Establim les propietats del request
    //[Request setEntity:entity];
    // Fem la select
    //seleccion  = [self.managedObjectContext executeFetchRequest:Request error:&error];
    if ([trimestres count] == 0 )
    {
        // No hi ha dades de trimestres, carreguem la taula
        [self inserta_trimestres];
    }
}


// Inserta els trimestres de l'any en curs
-(void)inserta_trimestres
{
    // Error
    NSError *error = nil;
    // Entity
    Trimestre *ltrimestre1 = [NSEntityDescription
                               insertNewObjectForEntityForName:@"Trimestre"
                               inManagedObjectContext:__managedObjectContext];
    // 1er Trimestre : ID = 1YYYY
    NSDate   *Inicitrimestre = [self get_inici_trimestre:@"01/01/"];
    NSDate   *Fitrimestre    = [self get_fi_trimestre:@"01/03/" :@"/03/"];
    // Movem les dades a persistent store
    [ltrimestre1 setAny:[self GetAnyActualDatef]];
    [ltrimestre1 setTxt:@"1er Trimestre"];
    [ltrimestre1 setDatini:Inicitrimestre];
    [ltrimestre1 setDatfin:Fitrimestre];
    // Gravem les dades
           Inicitrimestre = nil;
        Fitrimestre    = nil;
   
    // 2on Trimestre : ID = 2YYYY
      Trimestre *ltrimestre2 = [NSEntityDescription
                  insertNewObjectForEntityForName:@"Trimestre"
                  inManagedObjectContext:__managedObjectContext];
    Inicitrimestre = [self get_inici_trimestre:@"01/04/"];
    Fitrimestre    = [self get_fi_trimestre:@"01/06/" :@"/06/"];
    // Movem les dades a persistent store
    [ltrimestre2 setAny:[self GetAnyActualDatef]];
    [ltrimestre2 setTxt:@"2on Trimestre"];
    [ltrimestre2 setDatini:Inicitrimestre];
    [ltrimestre2 setDatfin:Fitrimestre];
       Inicitrimestre = nil;
        Fitrimestre    = nil;
    // 3er Trimestre : ID = 3YYYY
    Trimestre *ltrimestre3 = [NSEntityDescription
                  insertNewObjectForEntityForName:@"Trimestre"
                  inManagedObjectContext:__managedObjectContext];
    Inicitrimestre = [self get_inici_trimestre:@"01/07/"];
    Fitrimestre    = [self get_fi_trimestre:@"01/09/" :@"/09/"];
    // Movem les dades a persistent store
    [ltrimestre3 setAny:[self GetAnyActualDatef]];
    [ltrimestre3 setTxt:@"3r Trimestre"];
    [ltrimestre3 setDatini:Inicitrimestre];
    [ltrimestre3 setDatfin:Fitrimestre];
    
  
        Inicitrimestre = nil;
        Fitrimestre    = nil;
    
    // 4t  Trimestre : ID = 4YYYY
    Trimestre *ltrimestre4 = [NSEntityDescription
                  insertNewObjectForEntityForName:@"Trimestre"
                  inManagedObjectContext:__managedObjectContext];
    Inicitrimestre = [self get_inici_trimestre:@"01/10/"];
    Fitrimestre    = [self get_fi_trimestre:@"01/12/" :@"/12/"];
    // Movem les dades a persistent store
    [ltrimestre4 setAny:[self GetAnyActualDatef]];
    [ltrimestre4 setTxt:@"4t Trimestre"];
    [ltrimestre4 setDatini:Inicitrimestre];
    [ltrimestre4 setDatfin:Fitrimestre];
    // Gravem les dades
    if (![__managedObjectContext save:&error]) {
        // Handle the error.
        [self msg_pantalla:@"Error greu al inicialitzar trimestres!"];
    }
}

// Retorna el id de trimestre
-(NSNumber *)get_id_trimestre:(NSString *)idtrimestre
{
    // Formater para el id de trimestre
    NSNumberFormatter * formater = [[NSNumberFormatter alloc] init];
    [formater setNumberStyle:NSNumberFormatterDecimalStyle];
    
    
    //Obtenim l'any actual
    NSString *lstrAny = [self GetanyActual];
    // 1er Trimestre : ID = 1YYYY
    NSString *lstrTrimestre = [idtrimestre stringByAppendingString:lstrAny];
    return  [formater numberFromString:lstrTrimestre];
    
}

// Retorna l'inici de trimestre
-(NSDate *)get_inici_trimestre:(NSString *)inici
{
    
        // Formateador para fecha
        NSDateFormatter *df = [[NSDateFormatter alloc] init];
        [df setDateFormat:@"dd/MM/yyyy"];
        //Obtenim l'any actual
        NSString *lstrAny = [self GetanyActual];
        // Calculem la data inici del primer trimestre
        return [df dateFromString:[inici stringByAppendingString:lstrAny]];
    
}


// Retorna el fi de trimestre
-(NSDate *)get_fi_trimestre:(NSString *)fi
                           :(NSString *)mesfi
{
    // Formateador para fecha
    NSDateFormatter *df = [[NSDateFormatter alloc] init];
    [df setDateFormat:@"dd/MM/yyyy"];
    
    //Obtenim l'any actual
    NSString *lstrAny = [self GetanyActual];
    
    // Calculem la data fi del primer trimestre
    NSDate  *Diamesfi = [df dateFromString:[fi stringByAppendingString:lstrAny]];
    NSString *Fimes = [mesfi stringByAppendingString:lstrAny];
    return [df dateFromString:[[self Ultimdiames:Diamesfi] stringByAppendingString:Fimes]];

    
}



// Retrona l'ultim dia del mes
-(NSString *)Ultimdiames:(NSDate *)date
{
    int last_day = 27;
    NSCalendar *cal=[[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
    NSDateComponents *compsMonth = [cal components:NSWeekdayCalendarUnit | NSYearCalendarUnit | NSMonthCalendarUnit | NSDayCalendarUnit fromDate:date];
    [compsMonth setDay:last_day];
    NSInteger month = [compsMonth month];
    while(TRUE){
        [compsMonth setDay:last_day+1];
        NSDate *dateFuture = [cal dateFromComponents:compsMonth];
        NSDateComponents *futureComps = [cal components:NSWeekdayCalendarUnit | NSYearCalendarUnit | NSMonthCalendarUnit | NSDayCalendarUnit fromDate:dateFuture];
        if(month != [futureComps month]){
            return [NSString stringWithFormat:@"%d", last_day];
        }
        last_day+=1;
    }
    [NSString stringWithFormat:@"%d", last_day];
}

// Retorna l'any actual
-(NSString *) GetanyActual
{
    
    // Establecemos el formato de fecha
    NSDateFormatter *format = [[NSDateFormatter alloc] init];
    [format setDateFormat:@"yyyy"];
    // Obtenim l'any actual
    NSDate *fechaActual = [[NSDate alloc] init];
    // Obtenim l'any en format string
    NSString *dataInicial = [format stringFromDate:fechaActual];
    // Retornem el valor
    return dataInicial;
    
}

// Retorna l'any actual en format data
-(NSString *) GetAnyActualDatef
{
    // Establecemos el formato de fecha
    NSDateFormatter *format = [[NSDateFormatter alloc] init];
    [format setDateFormat:@"yyyy"];
    // Obtenim l'any actual
    NSDate *fechaActual = [[NSDate alloc] init];
    // Obtenim l'any en format string
    NSString *any = [format stringFromDate:fechaActual];
    return  any;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

- (void)saveContext
{
    NSError *error = nil;
    NSManagedObjectContext *managedObjectContext = self.managedObjectContext;
    if (managedObjectContext != nil)
    {
        if ([managedObjectContext hasChanges] && ![managedObjectContext save:&error])
        {
            /*
             Replace this implementation with code to handle the error appropriately.
             
             abort() causes the application to generate a crash log and terminate. You should not use this function in a shipping application, although it may be useful during development.
             */
            NSLog(@"Error imprevist %@, %@", error, [error userInfo]);
            abort();
        }
    }
}

#pragma mark - Core Data stack

/**
 Returns the managed object context for the application.
 If the context doesn't already exist, it is created and bound to the persistent store coordinator for the application.
 */
- (NSManagedObjectContext *)managedObjectContext
{
    if (__managedObjectContext != nil)
    {
        return __managedObjectContext;
    }
    
    NSPersistentStoreCoordinator *coordinator = [self persistentStoreCoordinator];
    if (coordinator != nil)
    {
        __managedObjectContext = [[NSManagedObjectContext alloc] init];
        [__managedObjectContext setPersistentStoreCoordinator:coordinator];
    }
    return __managedObjectContext;
}

/**
 Returns the managed object model for the application.
 If the model doesn't already exist, it is created from the application's model.
 */
- (NSManagedObjectModel *)managedObjectModel
{
    if (__managedObjectModel != nil)
    {
        return __managedObjectModel;
    }
    NSURL *modelURL = [[NSBundle mainBundle] URLForResource:@"TaxControl" withExtension:@"momd"];
    __managedObjectModel = [[NSManagedObjectModel alloc] initWithContentsOfURL:modelURL];
    return __managedObjectModel;
}

/**
 Returns the persistent store coordinator for the application.
 If the coordinator doesn't already exist, it is created and the application's store added to it.
 */
- (NSPersistentStoreCoordinator *)persistentStoreCoordinator
{
    NSError *error = nil;
    if (__persistentStoreCoordinator != nil)
    {
        return __persistentStoreCoordinator;
    }
    
    NSURL *storeURL = [[self applicationDocumentsDirectory] URLByAppendingPathComponent:@"TaxControl.sqlite"];
    

    __persistentStoreCoordinator = [[NSPersistentStoreCoordinator alloc] initWithManagedObjectModel:[self managedObjectModel]];
    if (![__persistentStoreCoordinator addPersistentStoreWithType:NSSQLiteStoreType configuration:nil URL:storeURL options:nil error:&error])
    {
        NSLog(@"Error al afegir el persistent Store %@, %@", error, [error userInfo]);
        abort();
    }
    
    return __persistentStoreCoordinator;
    
//    if (__persistentStoreCoordinator != nil)
//    {
//        return __persistentStoreCoordinator;
//    }
//    
//    // URL del Coredata
//    NSURL *storeURL = [[self applicationDocumentsDirectory] URLByAppendingPathComponent:@"TaxControl.sqlite"];
//    
//    // Icloud
//    NSFileManager *fileManager = [NSFileManager defaultManager];
//    __persistentStoreCoordinator = [[NSPersistentStoreCoordinator alloc] initWithManagedObjectModel:[self managedObjectModel]];
//    NSDictionary *options = nil;
//    // Team ID UOC : RVLW94ZY2B  Mio: NTJRKN6UEV
//    // App ID RVLW94ZY2B.uoc.edu.20131.
//    NSURL *cloudURL = [fileManager URLForUbiquityContainerIdentifier:@"RVLW94ZY2B.uoc.edu.20131."];
//    NSString* coreDataCloudContent = [[cloudURL path] stringByAppendingPathComponent:@"data"];
//    if ([coreDataCloudContent length] != 0) {
//        // Tenim iCloud
//        cloudURL = [NSURL fileURLWithPath:coreDataCloudContent];
//        
//        options = [NSDictionary dictionaryWithObjectsAndKeys:
//                   [NSNumber numberWithBool:YES], NSMigratePersistentStoresAutomaticallyOption,
//                   [NSNumber numberWithBool:YES], NSInferMappingModelAutomaticallyOption,
//                   @"TaxControlStore", NSPersistentStoreUbiquitousContentNameKey,
//                   cloudURL, NSPersistentStoreUbiquitousContentURLKey,
//                   nil];
//    } else {
//        // No tenim iCloud
//        options = [NSDictionary dictionaryWithObjectsAndKeys:
//                   [NSNumber numberWithBool:YES], NSMigratePersistentStoresAutomaticallyOption,
//                   [NSNumber numberWithBool:YES], NSInferMappingModelAutomaticallyOption,
//                   nil];
//    }
//    
//    
//
//    [__persistentStoreCoordinator lock];
//    if (![__persistentStoreCoordinator addPersistentStoreWithType:NSSQLiteStoreType configuration:nil URL:storeURL options:options error:&error])
//    {
//        NSLog(@"Error al afegir el persistent Store %@, %@", error, [error userInfo]);
//        abort();
//    }
//    [__persistentStoreCoordinator unlock];
//    
//    return __persistentStoreCoordinator;
}






#pragma mark - Application's Documents directory

/**
 Returns the URL to the application's Documents directory.
 */
- (NSURL *)applicationDocumentsDirectory
{
    return [[[NSFileManager defaultManager] URLsForDirectory:NSDocumentDirectory inDomains:NSUserDomainMask] lastObject];
}


// Missatges a pantalla
-(void)msg_pantalla:(NSString *)mensaje
{
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació" message:mensaje delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [alert show];
}


@end
