//
//  ClComunes.h
//  TaxControl
//
//  Created by Javier Cava García on 20/10/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "Categoria.h"
#import "SubCategoria.h"
#import "ImportFixe.h"
#import "TipusDIVA.h"
#import "TipusFactura.h"
#import "Categoria.h"

@interface ClComunes : NSObject


// Rutina per obtenir el managed object context
-(NSManagedObjectContext *)get_mngObj:(NSManagedObjectContext *)mngObj;
// Missatges a pantalla
-(void)msg_pantalla:(NSString *)mensaje;
// Missatge generic per excepció
-(void)msg_excepcio:(NSException *)excepcio;
// Rutina que carrega categories
-(NSMutableArray *)setCategories:(NSManagedObjectContext *)mngObj;
// Carrega les dades de l'entitat SubCategoria
-(NSMutableArray *)setSubCategories:(NSManagedObjectContext *)mngObj;
// Rutina que carrega tipus d'IVA
-(NSMutableArray *)setTipusDIVA:(NSManagedObjectContext *)mngObj;
// Rutina que carrega tipus de factures
-(NSMutableArray *)setTipusFactures:(NSManagedObjectContext *)mngObj;
// Retorna l'import fixe per una categoria/subcategoria
-(NSNumber *)get_import_fixe:(SubCategoria  *)Subcategoria
                            :(NSManagedObjectContext *)mngObj;
// Carrega les dades dels trimestres
-(NSMutableArray *)set_trimestres:(NSManagedObjectContext *)mngObj;
// Carrega les dades del parametre de imports fixes
-(NSMutableArray *)set_parametres_import_fixe:(NSManagedObjectContext *)mngObj;
// Carrega les dades dels quilometres
-(NSMutableArray *)set_quilometres:(NSManagedObjectContext *)mngObj;
// Carrega les dades del mail
-(NSMutableArray *)set_mail:(NSManagedObjectContext *)mngObj;
// Carrega les Subcategories d'una Categoria
-(NSMutableArray *)setSubCategoriesOfCategoria:(Categoria *)Categoria
                                              :(NSManagedObjectContext *)mngObj;
// Carrega les Despeses d'una Categoria
-(NSMutableArray * )hihatDespesesOfSubCategoria:(SubCategoria *)SubCategoria
                                               :(NSManagedObjectContext *)mngObj;
// Hiha Factures amb un tipus d'IVA?
-(NSMutableArray * )hihatFacturesOfTipIVA:(TipusDIVA *)TipusIva
                                         :(NSManagedObjectContext *)mngObj;
// Hi ha Subcategories amb un tipus d'IVA?
-(NSMutableArray * )hihatSubcategoriesfTipIVA:(TipusDIVA *)TipusIva
                                             :(NSManagedObjectContext *)mngObj;
// Hi ha Imports fixes per sl subcategoria?
-(NSMutableArray * )hihatImportsxSubcat:(SubCategoria *)SubCategoria
                                       :(NSManagedObjectContext *)mngObj;
// Hi ha Factures  per el tipus?
-(NSMutableArray * )hihatFacturesxTipus:(TipusFactura *)TipusFactura_IN
                                       :(NSManagedObjectContext *)mngObj;
// Retorna les referencies d'utilització per la categoria
-(NSMutableArray *)get_references_categoria:(Categoria *)Categoria
                                   :(NSManagedObjectContext *)mngObj;
// Retorna les referencies d'utilització per tipus d'IVA
-(NSMutableArray * )get_references_tipIVA:(TipusDIVA *)TipusIVA_In
                                         :(NSManagedObjectContext *)mngObj;
// Retorna les referencies d'utilització per SubCategoria
-(NSMutableArray * )get_references_Subcategoria:(SubCategoria *)Subcategoria_In
                                               :(NSManagedObjectContext *)mngObj;
// Retorna les referencies d'utilització per Tipus de factura
-(NSMutableArray * )get_references_tipusfactura:(TipusFactura *)TipusFactura_In
                                               :(NSManagedObjectContext *)mngObj;
// Retorna el porcentatge del tipus d'IVA
-(NSNumber *)get_porcen_tdiva:(NSNumber *)idIva
                             :(NSMutableArray *)arrayTipusdIVA;

// Carrega les dades de despeses
-(NSMutableArray *)set_despeses:(NSDate *)iniDate
                               :(NSDate *)fiDate
                               :(NSManagedObjectContext *)mngObj;
// Carrega les dades de factures
-(NSMutableArray *)set_factures:(NSDate *)iniDate
                               :(NSDate *)fiDate
                               :(NSManagedObjectContext *)mngObj;
// Carrega les dades de trajectes
-(NSMutableArray *)set_trajectes:(NSDate *)iniDate
                                :(NSDate *)fiDate
                                :(NSManagedObjectContext *)mngObj;
// Carrega les dades de trajectes
-(NSMutableArray *)set_trajectes_by_data:(NSDate *)Date
                                        :(NSManagedObjectContext *)mngObj;

// Carrega les dades de despeses
-(NSMutableArray *)set_despeses_by_data:(NSDate *)Date
                                       :(NSManagedObjectContext *)mngObj;

// Carrega les dades de factures
-(NSMutableArray *)set_factures_by_data:(NSDate *)Date
                                       :(NSManagedObjectContext *)mngObj;

// Retrona l'ultim dia del mes
-(NSString *)Ultimdiames:(NSDate *)date;
// Devuelve la fecha actual
-(NSDate *) GetfechaActual;
// Carrega les dades de despeses per una categoria / subcategoria
-(NSMutableArray *)get_despeses_by_filter:(Categoria *)Categoria
                                         :(SubCategoria *)Subcategoria
                                         :(NSMutableArray *)despeses;


//Retorna una categoria pel seu texte
-(Categoria *)get_categoria_by_txt:(NSString *)txt
                                  :(NSManagedObjectContext *)mngObj;


//Retorna un tipus d'iva pel seu texte
-(TipusDIVA *)get_tipusiva_by_txt:(NSString *)txt
                                 :(NSManagedObjectContext *)mngObj;

//Retorna una subcategoria pel seu texte i categoria
-(SubCategoria *)get_Subcategoria_by_txt:(Categoria *)Categoria
                                        :(TipusDIVA *)TipusIVA
                                        :(NSString *)txt
                                        :(NSManagedObjectContext *)mngObj;
//Retorna un tipus de factura pel seu texte
-(TipusFactura *)get_tipusfactura_by_txt:(NSString *)txt
                                        :(NSManagedObjectContext *)mngObj;
// Importacio de Categories
-(void)importa_categories:(NSArray *)Categories
                         :(NSManagedObjectContext *)mngObjectContext;
// Importacio de SubCategories
-(void)importa_Subcategories:(NSArray *)SubCategories
                            :(NSManagedObjectContext *)mngObjectContext;
// Importacio de tipus d'Iva
-(void)importa_tipusiva:(NSArray *)tipusiva
                       :(NSManagedObjectContext *)mngObjectContext;
@end
