//
//  ClComunes.m
//  TaxControl
//
//  Created by Javier Cava García on 20/10/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//

#import "ClComunes.h"
#import "AppDelegate.h"
#import "SubCategoria.h"
#import "TipusDIVA.h"
#import "TipusFactura.h"
#import "Trimestre.h"
#import "Categoria.h"


@interface ClComunes ()

@end

@implementation ClComunes



// Permet retorna el managepbjectcontext del Appdelegate
-(NSManagedObjectContext *)get_mngObj:(NSManagedObjectContext *)mngObj
{
    
    if (mngObj == nil)
    {
        return [(AppDelegate *)[[UIApplication sharedApplication] delegate] managedObjectContext];
    } else return mngObj;
}


// Missatges a pantalla
-(void)msg_pantalla:(NSString *)mensaje
{
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació" message:mensaje delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [alert show];
}

// Missatge generic per excepció
-(void)msg_excepcio:(NSException *)excepcio
{
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error Inesperat" message:[excepcio reason]   delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [alert show];
}


// Carrega les dades de l'entitat Categoria
-(NSMutableArray *)setCategories:(NSManagedObjectContext *)mngObj
{
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"Categoria" inManagedObjectContext:mngObj];
    // Establim l'ordre
    NSSortDescriptor *sort = [[NSSortDescriptor alloc] initWithKey:@"txt" ascending:YES];
    [Request setSortDescriptors:@[sort]];
    
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        
        return mutableFetchResults;
        
    } else return nil;
    
}



// Carrega les dades de l'entitat SubCategoria
-(NSMutableArray *)setSubCategories:(NSManagedObjectContext *)mngObj
{
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"SubCategoria" inManagedObjectContext:mngObj];
    // Establim l'ordre
    NSSortDescriptor *sort = [[NSSortDescriptor alloc] initWithKey:@"txt" ascending:YES];
    [Request setSortDescriptors:@[sort]];
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        return mutableFetchResults;
    } else return nil;
}



// Carrega les dades dels tipus d'IVA
-(NSMutableArray *)setTipusDIVA:(NSManagedObjectContext *)mngObj
{
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"TipusDIVA" inManagedObjectContext:mngObj];
    // Establim l'ordre
    NSSortDescriptor *sort = [[NSSortDescriptor alloc] initWithKey:@"txt" ascending:YES];
    [Request setSortDescriptors:@[sort]];
    
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        return mutableFetchResults;
    } else return nil;

}



// Carrega les dades dels tipus de factures
-(NSMutableArray *)setTipusFactures:(NSManagedObjectContext *)mngObj
{
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"TipusFactura" inManagedObjectContext:mngObj];
    // Establim l'ordre
    NSSortDescriptor *sort = [[NSSortDescriptor alloc] initWithKey:@"txt" ascending:YES];
    [Request setSortDescriptors:@[sort]];
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        return mutableFetchResults;
    } else return nil;
    
}


// Retorna l'import fixe per una categoria/subcategoria
-(NSNumber *)get_import_fixe:(SubCategoria  *)Subcategoria
                            :(NSManagedObjectContext *)mngObj
{
 
    
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"ImportFixe" inManagedObjectContext:mngObj];
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    [Request setPredicate:[NSPredicate predicateWithFormat:@"(subcategoria == %@)", Subcategoria]];
    
    ImportFixe *lImport = [[mngObj  executeFetchRequest:Request error:&error] lastObject];
    if ( lImport != nil && lImport.actiu.boolValue == TRUE)
    {
        return lImport.importfixe;
    }
    else return nil;
}

// Carrega les dades dels trimestres
-(NSMutableArray *)set_trimestres:(NSManagedObjectContext *)mngObj
{
    
    
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"Trimestre" inManagedObjectContext:mngObj];
    NSString *anyActual = [self GetAnyActualDatef];
    
    //[Request setPredicate:[NSPredicate predicateWithFormat:@"(any == %@)",@"2013"]];
    
    // Establim l'ordre
    NSSortDescriptor *sort = [[NSSortDescriptor alloc] initWithKey:@"datini" ascending:YES];
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    [Request setSortDescriptors:@[sort]];
    
    
    
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        
        for (int i = 0; i < [mutableFetchResults count]; i++)
        {
        
            Trimestre *ltrimestre = [mutableFetchResults objectAtIndex:i];
            if ( ![anyActual isEqualToString:ltrimestre.any] )
            {
                [mutableFetchResults removeObjectAtIndex:i];
            }
                
        }
        return  mutableFetchResults;
    }else return nil;
    
}



// Retorna l'any actual en format data
-(NSString *) GetAnyActualDatef
{
    // Establecemos el formato de fecha
    NSDateFormatter *format = [[NSDateFormatter alloc] init];
    [format setDateFormat:@"yyyy"];
    // Obtenim l'any actual
    NSDate *fechaActual = [[NSDate alloc] init];
    // Obtenim l'any en format string
    return [format stringFromDate:fechaActual];
}


// Carrega les dades del parametre de imports fixes
-(NSMutableArray *)set_parametres_import_fixe:(NSManagedObjectContext *)mngObj
{
    
    
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"ImportFixe" inManagedObjectContext:mngObj];
    // Establim l'ordre
    //NSSortDescriptor *sort = [[NSSortDescriptor alloc] initWithKey:@"id" ascending:YES];
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    //[Request setSortDescriptors:@[sort]];
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        return mutableFetchResults;
    }else return nil;
    
}


// Carrega les dades dels quilometres
-(NSMutableArray *)set_quilometres:(NSManagedObjectContext *)mngObj
{
    
    
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"Quilometre" inManagedObjectContext:mngObj];
    // Establim l'ordre
    NSSortDescriptor *sort = [[NSSortDescriptor alloc] initWithKey:@"km" ascending:YES];
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    [Request setSortDescriptors:@[sort]];
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        return mutableFetchResults;
    }else return nil;
    
}


// Carrega les dades del mail
-(NSMutableArray *)set_mail:(NSManagedObjectContext *)mngObj
{
    
    
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"Mail" inManagedObjectContext:mngObj];
    // Establim l'ordre
    NSSortDescriptor *sort = [[NSSortDescriptor alloc] initWithKey:@"mail" ascending:YES];
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    [Request setSortDescriptors:@[sort]];
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        return mutableFetchResults;
    }else return nil;
    
}



// Carrega les Subcategories d'una Categoria
-(NSMutableArray *)setSubCategoriesOfCategoria:(Categoria *)Categoria
                                              :(NSManagedObjectContext *)mngObj
{
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"SubCategoria" inManagedObjectContext:mngObj];
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    
    [Request setPredicate:[NSPredicate predicateWithFormat:@"(categoria == %@)", Categoria]];
    
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        return mutableFetchResults;
        
    } else return nil;
}



// Hi ha Despeses d'una SubCategoria?
-(NSMutableArray * )hihatDespesesOfSubCategoria:(SubCategoria *)SubCategoria
                                               :(NSManagedObjectContext *)mngObj
{
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"Despesa" inManagedObjectContext:mngObj];
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    
    [Request setPredicate:[NSPredicate predicateWithFormat:@"( subcategoria == %@)", SubCategoria]];
    
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    return mutableFetchResults;
}

// Hiha Factures amb un tipus d'IVA?
-(NSMutableArray * )hihatFacturesOfTipIVA:(TipusDIVA *)TipusIva
                                         :(NSManagedObjectContext *)mngObj
{
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"Factura" inManagedObjectContext:mngObj];
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    
    [Request setPredicate:[NSPredicate predicateWithFormat:@"(iva == %@)", TipusIva]];
    
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    return mutableFetchResults;
}

// Hi ha Subcategories amb un tipus d'IVA?
-(NSMutableArray * )hihatSubcategoriesfTipIVA:(TipusDIVA *)TipusIva
                                             :(NSManagedObjectContext *)mngObj
{
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"SubCategoria" inManagedObjectContext:mngObj];
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    
    [Request setPredicate:[NSPredicate predicateWithFormat:@"(iva == %@)", TipusIva]];
    
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    return mutableFetchResults;
}



// Hi ha Imports fixes per sl subcategoria?
-(NSMutableArray * )hihatImportsxSubcat:(SubCategoria *)SubCategoria
                                             :(NSManagedObjectContext *)mngObj
{
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"ImportFixe" inManagedObjectContext:mngObj];
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    
    [Request setPredicate:[NSPredicate predicateWithFormat:@"(subcategoria == %@)", SubCategoria]];
    
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    return mutableFetchResults;
}

// Hi ha Factures  per el tipus?
-(NSMutableArray * )hihatFacturesxTipus:(TipusFactura *)TipusFactura_IN
                                       :(NSManagedObjectContext *)mngObj
{
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"Factura" inManagedObjectContext:mngObj];
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    
    [Request setPredicate:[NSPredicate predicateWithFormat:@"(tipus == %@)", TipusFactura_IN]];
    
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    return mutableFetchResults;
}



// Retorna les referencies d'utilització per la categoria
-(NSMutableArray * )get_references_categoria:(Categoria *)Categoria_In
                                            :(NSManagedObjectContext *)mngObj
{
    
    // Comprobem si hi ha subcategories per aquesta categoria
    NSMutableArray *dades = [self setSubCategoriesOfCategoria:Categoria_In :mngObj];
    return dades;
}


// Retorna les referencies d'utilització per tipus d'IVA
-(NSMutableArray * )get_references_tipIVA:(TipusDIVA *)TipusIVA_In
                                         :(NSManagedObjectContext *)mngObj
{
    
    // Comprobem si hi ha tipus d'iva a facture
    NSMutableArray *dades = [self hihatFacturesOfTipIVA:TipusIVA_In :mngObj];
    if ( [dades count] == 0)
    {
        // Comprobem si hi ha tipus d'iva a Subcategories
        return [self hihatSubcategoriesfTipIVA:TipusIVA_In :mngObj];
    } else
    return dades;
}


// Retorna les referencies d'utilització per SubCategoria
-(NSMutableArray * )get_references_Subcategoria:(SubCategoria *)Subcategoria_In
                                               :(NSManagedObjectContext *)mngObj
{
    
    // Comprobem si hi ha subcategories a despeses
    NSMutableArray *dades = [self hihatDespesesOfSubCategoria:Subcategoria_In :mngObj];
    if ( [dades count] == 0)
    {
        return [self hihatImportsxSubcat:Subcategoria_In :mngObj];
    } else return dades;
}

// Retorna les referencies d'utilització per Tipus de factura
-(NSMutableArray * )get_references_tipusfactura:(TipusFactura *)TipusFactura_In
                                               :(NSManagedObjectContext *)mngObj
{
    
    // Comprobem si hi ha factures amb el tipus de factura
    NSMutableArray *dades = [self hihatFacturesxTipus:TipusFactura_In :mngObj];
    return dades;
    
    
}
// Retorna el porcentatge del tipus d'IVA
-(NSNumber *)get_porcen_tdiva:(NSNumber *)idIva
                            :(NSMutableArray *)arrayTipusdIVA
{
    // Establecemos el filtro
    NSPredicate *filter = [NSPredicate predicateWithFormat:@"id ==[c] %@", idIva];
    
    NSArray *filtered  = [arrayTipusdIVA filteredArrayUsingPredicate:filter];
    
    TipusDIVA *lTdiva  = (TipusDIVA *)[filtered   objectAtIndex:0];
    
    return lTdiva.percent;
    
}



// Carrega les dades de despeses
-(NSMutableArray *)set_despeses:(NSDate *)iniDate
                               :(NSDate *)fiDate
                               :(NSManagedObjectContext *)mngObj
{
    
    
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"Despesa" inManagedObjectContext:mngObj];
    // Establim l'ordre
    NSSortDescriptor *sort  = [[NSSortDescriptor alloc] initWithKey:@"data" ascending:YES];
    NSSortDescriptor *sort1 = [[NSSortDescriptor alloc] initWithKey:@"subcategoria.categoria.txt" ascending:YES];
    
    
    
    // Establim les hores de la data inicial i final per contemplar el timestamp
    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
    NSDateComponents *componentsIni = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:iniDate];
    [componentsIni setHour:00];
    NSDate *today00am = [calendar dateFromComponents:componentsIni];
    NSDateComponents *componentsFin = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:fiDate];
    [componentsFin setHour:23];
    [componentsFin setMinute:59];
    [componentsFin setSecond:59];
    NSDate *today24am = [calendar dateFromComponents:componentsFin];
    
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    [Request setSortDescriptors:[NSArray arrayWithObjects:sort,sort1, nil]];
    // Establim el where
    NSPredicate *lquery = [NSPredicate predicateWithFormat:@"(data >= %@) AND (data <= %@)",today00am,today24am];
    
    [Request setPredicate:lquery];
    
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        return mutableFetchResults;
    }else return nil;
    
}


// Carrega les dades de factures
-(NSMutableArray *)set_factures:(NSDate *)iniDate
                               :(NSDate *)fiDate
                               :(NSManagedObjectContext *)mngObj
{
    
    
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"Factura" inManagedObjectContext:mngObj];
    // Establim l'ordre
    NSSortDescriptor *sort  = [[NSSortDescriptor alloc] initWithKey:@"data" ascending:YES];
    NSSortDescriptor *sort1 = [[NSSortDescriptor alloc] initWithKey:@"tipus.txt" ascending:YES];
    
    
    
    // Establim les hores de la data inicial i final per contemplar el timestamp
    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
    NSDateComponents *componentsIni = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:iniDate];
    [componentsIni setHour:00];
    NSDate *today00am = [calendar dateFromComponents:componentsIni];
    NSDateComponents *componentsFin = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:fiDate];
    [componentsFin setHour:23];
    [componentsFin setMinute:59];
    [componentsFin setSecond:59];
    NSDate *today24am = [calendar dateFromComponents:componentsFin];
    
    
    
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    [Request setSortDescriptors:[NSArray arrayWithObjects:sort, sort1, nil]];
    // Establim el where
    NSPredicate *lquery = [NSPredicate predicateWithFormat:@"(data >= %@) AND (data <= %@)",today00am,today24am];
    
    [Request setPredicate:lquery];
    
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        return mutableFetchResults;
    }else return nil;
    
}


// Carrega les dades de trajectes
-(NSMutableArray *)set_trajectes:(NSDate *)iniDate
                                :(NSDate *)fiDate
                                :(NSManagedObjectContext *)mngObj
{
    
    
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"Trajecte" inManagedObjectContext:mngObj];
    // Establim l'ordre
    NSSortDescriptor *sort  = [[NSSortDescriptor alloc] initWithKey:@"data" ascending:YES];
    NSSortDescriptor *sort1 = [[NSSortDescriptor alloc] initWithKey:@"km" ascending:YES];
    
    
    // Establim les hores de la data inicial i final per contemplar el timestamp
    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
    NSDateComponents *componentsIni = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:iniDate];
    [componentsIni setHour:00];
    NSDate *today00am = [calendar dateFromComponents:componentsIni];
    NSDateComponents *componentsFin = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:fiDate];
    [componentsFin setHour:23];
    [componentsFin setMinute:59];
    [componentsFin setSecond:59];
    NSDate *today24am = [calendar dateFromComponents:componentsFin];
    
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    [Request setSortDescriptors:[NSArray arrayWithObjects:sort, sort1, nil]];
    // Establim el where
    NSPredicate *lquery = [NSPredicate predicateWithFormat:@"(data >= %@) AND (data <= %@)",today00am,today24am];
    
    [Request setPredicate:lquery];
    
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        return mutableFetchResults;
    }else return nil;
    
}

// Carrega les dades de trajectes
-(NSMutableArray *)set_trajectes_by_data:(NSDate *)Date
                                        :(NSManagedObjectContext *)mngObj
{
    
    
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"Trajecte" inManagedObjectContext:mngObj];
    // Establim l'ordre
    NSSortDescriptor *sort  = [[NSSortDescriptor alloc] initWithKey:@"data" ascending:YES];
    NSSortDescriptor *sort1 = [[NSSortDescriptor alloc] initWithKey:@"km" ascending:YES];
    // Establim les hores de la data inicial i final per contemplar el timestamp
    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
    NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:Date];
    [components setHour:00];
    NSDate *today00am = [calendar dateFromComponents:components];
    [components setHour:23];
    [components setMinute:59];
    [components setSecond:59];
    NSDate *today24am = [calendar dateFromComponents:components];
    
    
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    [Request setSortDescriptors:[NSArray arrayWithObjects:sort, sort1, nil]];
    // Establim el where
    NSPredicate *lquery = [NSPredicate predicateWithFormat:@"(data >= %@) AND (data <= %@)",today00am,today24am];

    
    [Request setPredicate:lquery];
    
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        return mutableFetchResults;
    }else return nil;
    
}



// Carrega les dades de despeses
-(NSMutableArray *)set_despeses_by_data:(NSDate *)Date
                                       :(NSManagedObjectContext *)mngObj
{
    
    
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"Despesa" inManagedObjectContext:mngObj];
    // Establim l'ordre
    NSSortDescriptor *sort  = [[NSSortDescriptor alloc] initWithKey:@"data" ascending:YES];
    NSSortDescriptor *sort1 = [[NSSortDescriptor alloc] initWithKey:@"subcategoria.categoria.txt" ascending:YES];
    
    //NSDate *now = [NSDate date];
    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
    NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:Date];
    [components setHour:00];
    
    NSDate *today00am = [calendar dateFromComponents:components];
    
    [components setHour:23];
    [components setMinute:59];
    [components setSecond:59];
    
    
    
    NSDate *today24am = [calendar dateFromComponents:components];
    
    
    
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    [Request setSortDescriptors:[NSArray arrayWithObjects:sort, sort1, nil]];
    // Establim el where
    NSPredicate *lquery = [NSPredicate predicateWithFormat:@"(data >= %@) AND (data <= %@)",today00am,today24am];
    
    
    [Request setPredicate:lquery];
    
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        return mutableFetchResults;
    }else return nil;
    
}


// Carrega les dades de factures
-(NSMutableArray *)set_factures_by_data:(NSDate *)Date
                                       :(NSManagedObjectContext *)mngObj
{
    
    
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"Factura" inManagedObjectContext:mngObj];
    // Establim l'ordre
    NSSortDescriptor *sort  = [[NSSortDescriptor alloc] initWithKey:@"data" ascending:YES];
    NSSortDescriptor *sort1 = [[NSSortDescriptor alloc] initWithKey:@"tipus.txt" ascending:YES];
    
    //NSDate *now = [NSDate date];
    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
    NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:Date];
    [components setHour:00];
    
    NSDate *today00am = [calendar dateFromComponents:components];
    
    [components setHour:23];
    [components setMinute:59];
    [components setSecond:59];
    
    
    
    NSDate *today24am = [calendar dateFromComponents:components];
    
    
    
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    [Request setSortDescriptors:[NSArray arrayWithObjects:sort, sort1, nil]];
    // Establim el where
    NSPredicate *lquery = [NSPredicate predicateWithFormat:@"(data >= %@) AND (data <= %@)",today00am,today24am];
    
    
    [Request setPredicate:lquery];
    
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        return mutableFetchResults;
    }else return nil;
    
}


// Retrona l'ultim dia del mes
-(NSString *)Ultimdiames:(NSDate *)date
{
    int last_day = 27;
    NSCalendar *cal=[[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
    NSDateComponents *compsMonth = [cal components:NSWeekdayCalendarUnit | NSYearCalendarUnit | NSMonthCalendarUnit | NSDayCalendarUnit fromDate:date];
    [compsMonth setDay:last_day];
    NSInteger month = [compsMonth month];
    while(TRUE){
        [compsMonth setDay:last_day+1];
        NSDate *dateFuture = [cal dateFromComponents:compsMonth];
        NSDateComponents *futureComps = [cal components:NSWeekdayCalendarUnit | NSYearCalendarUnit | NSMonthCalendarUnit | NSDayCalendarUnit fromDate:dateFuture];
        if(month != [futureComps month]){
            return [NSString stringWithFormat:@"%d", last_day];
        }
        last_day+=1;
    }
    [NSString stringWithFormat:@"%d", last_day];
}


// Devuelve la fecha actual
-(NSDate *) GetfechaActual
{
    
    // Establecemos el formato de fecha
    NSDateFormatter *format = [[NSDateFormatter alloc] init];
    [format setDateFormat:@"MMM dd, yyyy"];
    
    NSDate *fechaActual = [[NSDate alloc] init];
    
    return fechaActual;
    
}


// Carrega les dades de despeses per una categoria / subcategoria
-(NSMutableArray *)get_despeses_by_filter:(Categoria *)Categoria
                                         :(SubCategoria *)Subcategoria
                                         :(NSMutableArray *)despeses
{
    
    
    // Establecemos el filtro
    
    NSPredicate *filter  = [NSPredicate predicateWithFormat:@"( subcategoria == %@)",Subcategoria];
    
    NSArray *filtered  = [despeses filteredArrayUsingPredicate:filter];
    
    return [NSMutableArray arrayWithArray:filtered];

}

//Retorna una categoria pel seu texte
-(Categoria *)get_categoria_by_txt:(NSString *)txt
                                :(NSManagedObjectContext *)mngObj
{
    
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"Categoria" inManagedObjectContext:mngObj];
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    
    [Request setPredicate:[NSPredicate predicateWithFormat:@"(txt == %@)", txt]];
    
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        return [mutableFetchResults objectAtIndex:0];
        
    } else return nil;
    
    
}





//Retorna un tipus d'iva pel seu texte
-(TipusDIVA *)get_tipusiva_by_txt:(NSString *)txt
                                 :(NSManagedObjectContext *)mngObj
{
    
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"TipusDIVA" inManagedObjectContext:mngObj];
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    
    [Request setPredicate:[NSPredicate predicateWithFormat:@"(txt == %@)", txt]];
    
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        return [mutableFetchResults objectAtIndex:0];
        
    } else return nil;
    
    
}




//Retorna una subcategoria pel seu texte i categoria
-(SubCategoria *)get_Subcategoria_by_txt:(Categoria *)Categoria
                                        :(TipusDIVA *)TipusIVA
                                        :(NSString *)txt
                                        :(NSManagedObjectContext *)mngObj
{
    
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"SubCategoria" inManagedObjectContext:mngObj];
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    
    [Request setPredicate:[NSPredicate predicateWithFormat:@"(txt == %@) AND ( categoria == %@ ) AND ( iva == %@ )", txt,Categoria,TipusIVA]];
    
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        return [mutableFetchResults objectAtIndex:0];
        
    } else return nil;
    
}


//Retorna un tipus de factura pel seu texte
-(TipusFactura *)get_tipusfactura_by_txt:(NSString *)txt
                                     :(NSManagedObjectContext *)mngObj
{
    
    NSError *error;
    NSFetchRequest *Request = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription  entityForName:@"TipusFactura" inManagedObjectContext:mngObj];
    [Request setEntity:entity];
    [Request setReturnsObjectsAsFaults:NO];
    
    [Request setPredicate:[NSPredicate predicateWithFormat:@"(txt == %@)", txt]];
    
    NSMutableArray *mutableFetchResults  = [[mngObj   executeFetchRequest:Request error:&error] mutableCopy];
    
    if ( [mutableFetchResults count] > 0 )
    {
        return [mutableFetchResults objectAtIndex:0];
        
    } else return nil;
    
    
}

// Importacio de Categories
-(void)importa_categories:(NSArray *)Categories
                         :(NSManagedObjectContext *)mngObjectContext
{
    NSError *errorSave;
    int i = 0;
    // Obtenim el manageObject
    
    for (NSArray *row in Categories)
    {
        
        // Establim la entitat
        Categoria *lCat = [NSEntityDescription
                           insertNewObjectForEntityForName:@"Categoria"
                           inManagedObjectContext:mngObjectContext];
        // Dividim en parts els registres ( En aquest cas no te mol de sentit, perque unicament tenim un camp )
        NSArray *parts = [[row objectAtIndex:0] componentsSeparatedByString:@";"];
        // Establim els atributs
        // Descripció de la categoria
        [lCat setValue:[parts objectAtIndex:0] forKey :@"txt"];
        // Increment bucle
        i++;
        
    }
    
    // Set al persitent store
    BOOL success = [mngObjectContext save:&errorSave];
    if (success)
    {
        [self msg_pantalla:@"Categories importades correctament!"];
    } else
    {
        [self msg_pantalla:@"Error durant la importació de Categories"];
        
    }
 }


// Importacio de SubCategories
-(void)importa_Subcategories:(NSArray *)SubCategories
                            :(NSManagedObjectContext *)mngObjectContext
{
    NSError *errorSave;
    int i = 0;
    // Carreguem les categories i el tipus d'IVA ja que són
    // necessaris per donar d'alta subcategories
    NSMutableArray *categories = [self setCategories:mngObjectContext];
    NSMutableArray *tipusIVA   = [self setTipusDIVA:mngObjectContext];
    
    // Si no tenim qualsevol del dos arrays no es podem carregar subcategories
    if ( categories == nil)
    {
        [self msg_pantalla:@"No existeixen categories, imposible importar subcategories!"];
        return;
    }
    else if ( tipusIVA == nil)
    {
        [self msg_pantalla:@"No existeixen tipus d'Iva, imposible importar subcategories!"];
        return;
    }
    
    for (NSArray *row in SubCategories)
    {
        // Dividim en parts els registres ( En aquest cas no te mol de sentit, perque unicament tenim un camp )
        NSArray *parts = [[row objectAtIndex:0] componentsSeparatedByString:@";"];
        // Establim la entitat
        SubCategoria *lSubCateforia = [NSEntityDescription
                                       insertNewObjectForEntityForName:@"SubCategoria"
                                       inManagedObjectContext:mngObjectContext];
        // Descripció de la Subcategoria
        [lSubCateforia setValue:[parts objectAtIndex:0] forKey :@"txt"];
        // Recuperem la categoria pel texte
        Categoria *lCategoria = [self get_categoria_by_txt:[parts objectAtIndex:1] :mngObjectContext];
        if ( lCategoria == nil)
        {
             [self msg_pantalla:[NSString stringWithFormat:@"No existeix la Categoria %@", [parts objectAtIndex:1]]];
        }
        else
        lSubCateforia.categoria= lCategoria;
        // Obtenim el tipus d'IVA
        TipusDIVA *lTipusDIVA = [self get_tipusiva_by_txt:[parts objectAtIndex:2] :mngObjectContext];
        if ( lCategoria == nil)
        {
            [self msg_pantalla:[NSString stringWithFormat:@"No existeix el tipus d'IVA %@", [parts objectAtIndex:2]]];
        }
        else
        lSubCateforia.iva = lTipusDIVA;
        // Increment bucle
        i++;
        
    }
    
    // Set al persitent store
    BOOL success = [mngObjectContext save:&errorSave];
    if (success)
    {
        [self msg_pantalla:@"SubCategories importades correctament!"];
    } else
    {
        [self msg_pantalla:@"Error durant la importació de SubCategories"];
        
    }
}



// Importacio de tipus d'Iva
-(void)importa_tipusiva:(NSArray *)tipusiva
                       :(NSManagedObjectContext *)mngObjectContext
{
    NSError *errorSave;
    int i = 0;
    
    for (NSArray *row in tipusiva)
    {
        // Dividim en parts els registres ( En aquest cas no te mol de sentit, perque unicament tenim un camp )
        NSArray *parts = [[row objectAtIndex:0] componentsSeparatedByString:@";"];
        // Establim la entitat
        TipusDIVA *lTipus = [NSEntityDescription
                             insertNewObjectForEntityForName:@"TipusDIVA"
                             inManagedObjectContext:mngObjectContext];
        
        [lTipus setTxt:[parts objectAtIndex:0]];
        [lTipus setPercent:[NSDecimalNumber decimalNumberWithString:[parts objectAtIndex:1]]];
        // Increment bucle
        i++;
        
    }
    
    // Set al persitent store
    BOOL success = [mngObjectContext save:&errorSave];
    if (success)
    {
        [self msg_pantalla:@"Tipus d'IVA importats correctament!"];
    } else
    {
        [self msg_pantalla:@"Error durant la importació dels Tipus d'IVA"];
        
    }
}





@end
