//
//  ClScrConfiguracio.m
//  TaxControl
//
//  Created by Javier Cava García on 12/10/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//

#import "ClScrConfiguracio.h"
#import "ClScrCategories.h"
#import "ClScrSubCategories.h"
#import "ClScrTipusDIVA.h"
#import "ClScrTrimestres.h"
#import "ClScrTipusFactures.h"
#import "ClScrParametres.h"

@interface ClScrConfiguracio ()


@end

@implementation ClScrConfiguracio
{
    NSInteger itemSelected;
    ClComunes *funcComunes;
}

@synthesize btnManteniment;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    // Carreguem les opcions
    // Establim el fons
    @try {
        // Intanciem comunes
        funcComunes = [ClComunes alloc];
        
        self.view.backgroundColor = [[UIColor alloc] initWithPatternImage:[UIImage       imageNamed:@"Background.png"]];
        _itemsCfg = [[NSArray alloc] initWithObjects:@"CATEGORIES", @"TIPUS D'IVA",@"SUBCATEGORIES", @"TIPUS DE FACTURES",@"PARÀMETRES",@"TRIMESTRES",nil];
        [btnManteniment setTitle: [NSString stringWithFormat:@"Veure detall :%@",[self.itemsCfg objectAtIndex:0]] forState:UIControlStateNormal];
        
        btnManteniment.layer.cornerRadius = 15;
        btnManteniment.layer.borderWidth = 1.5;
        [btnManteniment.layer setBorderColor:[[UIColor blueColor] CGColor]];
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

// Nombre de components
- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)cfgItems
{
    return 1;
}



// Nombre de registres / opcions
- (NSInteger)pickerView:(UIPickerView *)cfgItems numberOfRowsInComponent: (NSInteger)component
{
    return [self.itemsCfg count];
}

// Texte de les files
-(NSString *)pickerView:(UIPickerView *)cfgItems  titleForRow:(NSInteger)row   forComponent:(NSInteger)component
{
    return [self.itemsCfg objectAtIndex:row];
    
}
// Actualizatzació de la fila seleccionada
- (void)pickerView:(UIPickerView *)cfgItems didSelectRow:(NSInteger)row   inComponent:(NSInteger)component
{
    // Actualizamos el item seleccionado
    itemSelected = row;
    [btnManteniment setTitle: [NSString stringWithFormat:@"Veure detall :%@",[self.itemsCfg objectAtIndex:row]] forState:UIControlStateNormal];
    
}




//Navegació a les diferents opcions
- (IBAction)btnManteniment:(UIButton *)sender {
    @try {
        switch (itemSelected) {
            case 0: // categories
            {
                ClScrCategories *categoriesView = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewCategories"];
                
                [self.navigationController pushViewController:categoriesView animated:YES];
                break;
            }
            case 1: // Tipus D'IVA
            {
                ClScrTipusDIVA *tipusdivaView = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewTipusDIVA"];
                [self.navigationController pushViewController:tipusdivaView animated:YES];
                break;
            }
                
                
            case 2: // Subcategories
            {
                ClScrSubCategories *subcategoriesView = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewSubcategories"];
                [self.navigationController pushViewController:subcategoriesView animated:YES];
                break;
            }
                
            case 3: // Tipus de Factures
            {
                ClScrTipusFactures *tipusfacturesView = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewTipusFactures"];
                [self.navigationController pushViewController:tipusfacturesView animated:YES];
                break;
            }
                
            case 4: // Parametres
            {
                ClScrParametres *parametresView = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewParametres"];
                [self.navigationController pushViewController:parametresView animated:YES];
                break;
            }
            case 5: // Trimestres
            {
                ClScrTrimestres *trimestresView = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewTrimestres"];
                [self.navigationController pushViewController:trimestresView animated:YES];
                break;
            }
                
                
            default:
                break;
        }
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}
@end
