//
//  ClScrDespeses.m
//  TaxControl
//
//  Created by Javier Cava García on 18/10/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//

#import "ClScrDespeses.h"
#import "Categoria.h"
#import "SubCategoria.h"
#import "TipusDIVA.h"
#import "ClComunes.h"
#import "Despesa.h"


@interface ClScrDespeses ()

@end

@implementation ClScrDespeses
{
    ClComunes *funcComunes;

}


// Array de Subcategories
@synthesize SubCategoriesArray;
// Core data
@synthesize managedObjectContext;
// Variables
@synthesize datePicker;
@synthesize txtCategoria;
@synthesize txtSubCat;
@synthesize txtImport;
@synthesize txtImportIVA;
@synthesize txtPorcenIVA;
@synthesize txtTipusIVA;
@synthesize txtConcepte;
@synthesize btngravar;


@synthesize edicio;
@synthesize DespesaEdit;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}


-(void)viewWillAppear:(BOOL)animated
{
    
    @try {
        // Carreguem les Subcategories
        NSMutableArray *mutableFetchResults  = [funcComunes setSubCategories:managedObjectContext];
        [self setSubCategoriesArray:mutableFetchResults];
        mutableFetchResults = nil;
        // Si estem editant
        if ( [edicio  isEqual: @1] )
        {
            // Carreguem dades
            txtConcepte.text  = DespesaEdit.concepte;
            // Recuperem l'import
            NSNumber *import = DespesaEdit.import;
            // Convertim a String
            txtImport.text = [NSString stringWithFormat:@"%.2f", import.doubleValue];
            // Obtenim la categoria i Subcategoria de la despesa
            Categoria *lCategoria = DespesaEdit.subcategoria.categoria;
            txtCategoria.text = lCategoria.txt;
            self.stepCategoria.value = [SubCategoriesArray indexOfObject:DespesaEdit.subcategoria];
            
            SubCategoria *lSubcategoria = DespesaEdit.subcategoria;
            txtSubCat.text = lSubcategoria.txt;
            datePicker.date = DespesaEdit.data;
            // Deshabilitem el datepicker
            //[datePicker setUserInteractionEnabled:FALSE];
            // Amb la subcategoria ya tenim el tipus d'iva, obtenim la seva entitat per informar la resta de camps
            TipusDIVA *LtipusIVA = lSubcategoria.iva;
            // Informem els camps
            txtTipusIVA.text  = LtipusIVA.txt;
            txtPorcenIVA.text = [LtipusIVA.percent stringValue];
            // Establim l'import d'iva
            [self setImportIva];
            // Configuren el stepper de categories
            [self configura_step_categoria:FALSE];
            
        }
        else
        {
            
            // Configuren el stepper de categories
            [self configura_step_categoria:TRUE];
            // Si no tenim Subcategories no es podem
            // insertar despeses
            if (  SubCategoriesArray == nil )
            {
                // Misstage
                [funcComunes msg_pantalla: @"Imposible registrar despeses, configuració necessaria!"];
                // Desactivem el botó gravar
                btngravar.enabled = false;
            } else btngravar.enabled = true;
            // Intentem carregar l'import fixe
            [self carrega_import_fixe];
        }
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    @try {
        
        // Establim el fons
        self.view.backgroundColor = [[UIColor alloc] initWithPatternImage:[UIImage  imageNamed:@"Background.png"]];
        // Do any additional setup after loading the view.
        // Intanciem comunes
        funcComunes = [ClComunes alloc];
        // Obtenim les dades necessaries per la gestió del Coredata
        managedObjectContext = [funcComunes get_mngObj:managedObjectContext];
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}


- (IBAction)txtImportEnd:(id)sender {
     [txtImport resignFirstResponder];
}



- (IBAction)txtConcepteEnd:(id)sender {
    [txtConcepte  resignFirstResponder];
}

- (IBAction)txtImportIvaValChg:(id)sender {
    
    [self setImportIva];
    
}

// Calcula l'import de l?IVA
-(void)setImportIva
{
    @try {
        
        SubCategoria *lSubCategoria = (SubCategoria *) [SubCategoriesArray objectAtIndex:self.stepCategoria.value];
        // Obtenim el percentatge
        double porcen = [lSubCategoria.iva.percent integerValue];
        // Obtenim l'import d' IVA
        double import = [txtImport.text floatValue] * porcen;
        // Dividem per 100 pel porcentatge
        import = import / 100;
        // Convertim a String
        NSString *str = [NSString stringWithFormat:@"%.2f €", import];
        // Actulitzaem
        txtImportIVA.text =  str;
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}

// Configura step categories
-(void)configura_step_categoria:(Boolean )iniStep
{
    if (iniStep == TRUE)[self.stepCategoria setStepValue: 1];
    [self.stepCategoria setMinimumValue:0];
    if ( SubCategoriesArray == nil )
    {
        [self.stepCategoria setMaximumValue:0];
    } else [self.stepCategoria setMaximumValue:[SubCategoriesArray count]-1];
    // Inicialitzem el text de la categoria
    if ( [txtCategoria text].length == 0)
    {
        NSUInteger iniValCat = 0;
        [self setvalors_txt:&iniValCat];
        
    }
    
}





// Estableix el valor de la categoria en funció de l'index d'entrada
// i l'array de categories
-(void)setvalors_txt:(NSUInteger *)index
{
    
    SubCategoria *lSubcategoria  = (SubCategoria *)[SubCategoriesArray   objectAtIndex:  *index];
    if ( lSubcategoria != nil )
    {
        txtCategoria.text = lSubcategoria.categoria.txt;
        txtSubCat.text    = lSubcategoria.txt;
        TipusDIVA *lTipusIva = lSubcategoria.iva;
        
        txtTipusIVA.text  = lTipusIva.txt;
        txtPorcenIVA.text = [NSString stringWithFormat:@"%@", lTipusIva.percent];
    }
}





// Canvi de valor a step categoria
- (IBAction)stepCategoriaChangeValue:(UIStepper *)sender {
    
    NSUInteger stepvalue = [sender value];
    if ( ( stepvalue <= [SubCategoriesArray count]-1 ))
    {
        [self setvalors_txt:&stepvalue];
        [self configura_step_categoria:FALSE];
        // Si hi ha canvi de categoria, actualitzem l'import fixe
        [self carrega_import_fixe];
        [self setImportIva];
     
    }
}

// Carrega un import fixe per categoria / subcategoria
-(void)carrega_import_fixe
{
    // Carreguem el valor per defecte si existeix
    // Intentem carregar l'import
    SubCategoria *lSubCategoria = (SubCategoria *) [SubCategoriesArray objectAtIndex:self.stepCategoria.value];

    NSNumber *importF = [funcComunes get_import_fixe:lSubCategoria  :managedObjectContext];
    if ( importF != nil )
    {
        NSString *strImport = [NSString stringWithFormat:@"%.2f ", [importF doubleValue]];
        txtImport.text = strImport;
        [self setImportIva];
        
    }    
}




- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

// Gravar despeses
- (IBAction)btnSave:(id)sender {
    
    // Comprovem dades abans de gravar
    
    NSError *error = nil;
    
    @try {
        // Unicament grabem si s'han introduit les dades adequades
        if ( [txtImport text].length == 0 )
        {
            [funcComunes msg_pantalla: @"Indiqui un Import"];
        }
        else
        {
            
            if ( [edicio  isEqual: @1])
            {
                [DespesaEdit setConcepte:txtConcepte.text];
                [DespesaEdit setImport:[NSNumber numberWithDouble:txtImport.text.doubleValue]];
                [DespesaEdit setData:datePicker.date];
                SubCategoria *lSubCategoria = [SubCategoriesArray objectAtIndex:self.stepCategoria.value];
                [DespesaEdit setSubcategoria:lSubCategoria];
            }
            else
            {
                // Guardar dades
                Despesa *lDespesa = [NSEntityDescription
                                     insertNewObjectForEntityForName:@"Despesa"
                                     inManagedObjectContext:managedObjectContext];
                [lDespesa setConcepte:txtConcepte.text];
                [lDespesa setImport:[NSNumber numberWithDouble:txtImport.text.doubleValue]];
                SubCategoria *lSubCategoria = [SubCategoriesArray objectAtIndex:self.stepCategoria.value];
                lDespesa.subcategoria = lSubCategoria;
                [lDespesa setData: datePicker.date];
            }
        }
        // Save
        BOOL Succes = [managedObjectContext save:&error];
        if (!Succes ) {
            // Handle the error.
            [funcComunes msg_pantalla: @"Error al gravar la despesa!"];
        }else
        {
            //Mostrem misstatge
            [funcComunes msg_pantalla:@"Despesa gravada correctament"];
        }
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}
@end
