//
//  ClScrFacturacio.m
//  TaxControl
//
//  Created by Javier Cava García on 06/11/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//

#import "ClScrFacturacio.h"
#import "ClComunes.h"
#import "Trimestre.h"
#import "Factura.h"

@interface ClScrFacturacio ()

@end

@implementation ClScrFacturacio
{
    ClComunes *funcComunes;
}


// Core data
@synthesize managedObjectContext;
// Variables
@synthesize txtTipusFactura;
@synthesize txtConcepte;
@synthesize txtNIFCIF;
@synthesize txtRaoSocial;
@synthesize txtBaseFactura;
@synthesize txtTipusDIVA;
// Arrays
@synthesize TipusFacturesArray;
@synthesize TipusDIVAArray;


@synthesize datePicker;
@synthesize btngravar;

//Edicio
@synthesize edicio;
@synthesize FacturaEdit;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

-(void)viewWillAppear:(BOOL)animated
{
    // Carreguem les dades necessaries
    // Carreguem els tipus de factures
    @try {
        NSMutableArray *mutableFetchResults  = [funcComunes setTipusFactures :managedObjectContext];
        [self setTipusFacturesArray:mutableFetchResults];
        // Carreguem els tipus d'IVA
        mutableFetchResults = nil;
        mutableFetchResults  = [funcComunes setTipusDIVA:managedObjectContext];
        [self setTipusDIVAArray:mutableFetchResults];
        
        // Si estem editant
        if ( [edicio  isEqual: @1] )
        {
            // Recuperem les dades de la factura
            // Data
            datePicker.date = FacturaEdit.data;
            //[datePicker setUserInteractionEnabled:FALSE];
            // Tipus
            TipusFactura *lTipusFactura = FacturaEdit.tipus;
            txtTipusFactura.text = lTipusFactura.txt;
            self.stepTipusFactura.value = [TipusFacturesArray indexOfObject:lTipusFactura];
            
            // Concepte
            txtConcepte.text     = FacturaEdit.concepte;
            // NIF/CIF
            txtNIFCIF.text       = FacturaEdit.nifcif;
            // Rao social
            txtRaoSocial.text    = FacturaEdit.raosocial;
            // Base
            // Recuperem l'import
            NSNumber *import = FacturaEdit.base;
            // Convertim a String
            txtBaseFactura.text = [NSString stringWithFormat:@"%.2f", import.doubleValue];
            // IVA
            TipusDIVA *lTipusIVA = FacturaEdit.iva;
            txtTipusDIVA.text = lTipusIVA.txt;
            self.stepTipusDIVA.value = [TipusDIVAArray indexOfObject:lTipusIVA];
            // Configurem els steppers
            [self configura_step_tipusdiva:FALSE];
            [self configura_step_tipus_factures:FALSE];
        }
        else
        {
            // Si no estem editant, per defecte fem que la data sigui l'ultim dia del mes
            // actual, ja que es lo normal en facturació
            //datePicker.date = [funcComunes Ultimdiames:[funcComunes GetfechaActual]];
            // Configurem els steppers
            [self configura_step_tipusdiva:TRUE];
            [self configura_step_tipus_factures:TRUE];
        }
        
        // Si no tenim tipus d'iva ni de factures no es podem
        // insertar factures
        if (( TipusFacturesArray == nil ) || ( TipusDIVAArray == nil) )
        {
            // Missatge
            [funcComunes msg_pantalla: @"Imposible registrar factures, configuració necessaria!"];
            // Desactivem el botó gravar
            btngravar.enabled = false;
        } else btngravar.enabled = true;
        
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    @try {
        // Establim el fons
        self.view.backgroundColor = [[UIColor alloc] initWithPatternImage:[UIImage imageNamed:@"Background.png"]];
        // Do any additional setup after loading the view.
        // Intanciem comunes
        funcComunes = [ClComunes alloc];
        // Obtenim les dades necessaries per la gestió del Coredata
        managedObjectContext = [funcComunes get_mngObj:managedObjectContext];
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}




// Configura step tipus factures
-(void)configura_step_tipus_factures:(Boolean )iniStep
{
    
    if ( iniStep == TRUE ) [self.stepTipusFactura setStepValue: 1];
    [self.stepTipusFactura setMinimumValue:0];
    [self.stepTipusFactura setMaximumValue:[TipusFacturesArray count]-1];
    // Inicialitzem el text de la categoria
    if ( [txtTipusFactura text].length == 0)
    {
        NSUInteger ini = 0;
        [self setvalortipusfactura:&ini];
    }
    
}

// Configura step tipus d'IVA
-(void)configura_step_tipusdiva:(Boolean )iniStep
{
    if ( iniStep == TRUE ) [self.stepTipusDIVA setStepValue: 1];
    [self.stepTipusDIVA setMinimumValue:0];
    [self.stepTipusDIVA setMaximumValue:[TipusDIVAArray count]-1];
    // Inicialitzem el text de la categoria
    if ( [txtTipusDIVA text].length == 0)
    {
        NSUInteger ini = 0;
        [self setvalortipusdiva:&ini];
    }
    
}


// Estableix el valor del tipus d'IVA en funció de l'index d'entrada
// i l'array de categories
-(void)setvalortipusdiva:(NSUInteger *)index
{
    
    TipusDIVA *lTipusdiva  = (TipusDIVA *)[TipusDIVAArray   objectAtIndex:  *index];
    txtTipusDIVA.text = lTipusdiva.txt;
    
}


// Estableix el valor del tipus de factura
-(void)setvalortipusfactura:(NSUInteger *)index
{
    
    TipusFactura *lTipusF  = (TipusFactura *)[TipusFacturesArray   objectAtIndex:  *index];
    txtTipusFactura.text = lTipusF.txt;
    
}





- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)tipusFChgValue:(UIStepper *)sender {
    
    NSUInteger stepvalue = [sender value];
    if ( ( stepvalue <= [TipusFacturesArray  count]-1 ))
        [self setvalortipusfactura:&stepvalue];
    
}



- (IBAction)tipusIVAChgValue:(UIStepper *)sender
{
    NSUInteger stepvalue = [sender value];
    if ( ( stepvalue <= [TipusDIVAArray count]-1 ))
        [self setvalortipusdiva:&stepvalue];
}


// Ocultar teclat
-(IBAction) txtDoneEditing : (id) sender{
    [sender resignFirstResponder];
}


// Gravar despeses
- (IBAction)btnSave:(id)sender {
    
    // Comprovem dades abans de gravar
    
    NSError *error = nil;
    
    @try {
        // Unicament grabem si s'han introduit les dades adequades
        if ( [txtConcepte text].length == 0 )
        {
            [funcComunes msg_pantalla: @"Indiqui un concepte"];
        }
        else if ( [txtNIFCIF text].length == 0 )
        {
            [funcComunes msg_pantalla: @"Indiqui un NIF/CIF valid"];
        } else if ( [txtRaoSocial text].length == 0 )
        {
            [funcComunes msg_pantalla: @"Indiqui una raó social"];
        } else if ( [txtBaseFactura text].length == 0 )
        {
            [funcComunes msg_pantalla: @"Indiqui la base de la factura"];
        }
        else
        {
            
            if ( [edicio  isEqual: @1])
            {
                
                [FacturaEdit setConcepte:txtConcepte.text];
                [FacturaEdit setNifcif:txtNIFCIF.text];
                [FacturaEdit setRaosocial:txtRaoSocial.text];
                [FacturaEdit setBase:[NSNumber numberWithDouble:txtBaseFactura.text.doubleValue]];
                FacturaEdit.iva   = [TipusDIVAArray objectAtIndex:self.stepTipusDIVA.value];
                FacturaEdit.tipus = [TipusFacturesArray objectAtIndex:self.stepTipusFactura.value];
                [FacturaEdit setData:datePicker.date];
                
            }
            else
            {
                // Guardar dades
                Factura *lFactura = [NSEntityDescription
                                     insertNewObjectForEntityForName:@"Factura"
                                     inManagedObjectContext:managedObjectContext];
                
                [lFactura setData:datePicker.date];
                [lFactura setConcepte:txtConcepte.text];
                [lFactura setNifcif:txtNIFCIF.text];
                [lFactura setRaosocial:txtRaoSocial.text];
                [lFactura setBase:[NSNumber numberWithDouble:txtBaseFactura.text.doubleValue]];
                lFactura.iva   = [TipusDIVAArray objectAtIndex:self.stepTipusDIVA.value];
                lFactura.tipus = [TipusFacturesArray objectAtIndex:self.stepTipusFactura.value];
            }
        }
        // Save
        if (![managedObjectContext save:&error]) {
            // Handle the error.
            [funcComunes msg_pantalla: @"Error al gravar la factura!"];
        }else
        {
            //Mostrem misstatge
            [funcComunes msg_pantalla:@"Factura gravada correctament"];
        }
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}


@end
