//
//  ClScrInicial.m
//  TaxControl
//
//  Created by Javier Cava García on 12/10/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//

#import "ClScrInicial.h"

@interface ClScrInicial ()
{
    // Valor per transparencia
    float  Alpha_value;
}
@end


@implementation ClScrInicial
{
        ClComunes *funcComunes;
}
@synthesize lblFechaActual;
@synthesize btnDespeses;
@synthesize btnFacturacio;
@synthesize btnGestioDespeses;
@synthesize btnGestioFactures;
@synthesize btnTrajectes;
@synthesize btnGestioTrajectes;
@synthesize btnExportacio;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    @try {
        // Intanciem comunes
        funcComunes = [ClComunes alloc];
        // Do any additional setup after loading the view.
        [self Inicializa];
        
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}

-(void)viewWillDisappear:(BOOL)animated
{
    

}

// Preparació de transparencies
-(void)Inicializa
{
    // Establim el valor de transparencia
    Alpha_value = 0.4;
    // Inicializamos el label que contiene la fecha del día
    [self inicializaLabelFecha];
    // set  la imatge de fons
    self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"Background"]];
    // Set  botons
    btnDespeses.layer.cornerRadius = 15;
    btnDespeses.layer.borderWidth = 1;
    [btnDespeses.layer setBorderColor:[[UIColor blueColor] CGColor]];
    btnFacturacio.layer.cornerRadius = 15;
    btnFacturacio.layer.borderWidth = 1;
    [btnFacturacio.layer setBorderColor:[[UIColor blueColor] CGColor]];
    btnTrajectes.layer.cornerRadius = 15;
    btnTrajectes.layer.borderWidth = 1;
    [btnTrajectes.layer setBorderColor:[[UIColor blueColor] CGColor]];
    
    btnGestioDespeses.layer.cornerRadius = 15;
    btnGestioDespeses.layer.borderWidth = 1.5;
    [btnGestioDespeses.layer setBorderColor:[[UIColor blueColor] CGColor]];
    btnGestioFactures.layer.cornerRadius = 15;
    btnGestioFactures.layer.borderWidth = 1.5;
    [btnGestioFactures.layer setBorderColor:[[UIColor blueColor] CGColor]];
    btnGestioTrajectes.layer.cornerRadius = 15;
    btnGestioTrajectes.layer.borderWidth = 1.5;
    [btnGestioTrajectes.layer setBorderColor:[[UIColor blueColor] CGColor]];
    btnExportacio.layer.cornerRadius = 15;
    btnExportacio.layer.borderWidth = 1.5;
    [btnExportacio.layer setBorderColor:[[UIColor  blueColor] CGColor]];
    
    
    
}
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


//------------------------------------------------------------------------------------------
// Inicializa el Label de la fecha Actual
//------------------------------------------------------------------------------------------
-(void) inicializaLabelFecha
{
    NSDateFormatter *format = [[NSDateFormatter alloc] init];
    [format setDateFormat:@"dd MMMM yyyy"];
    // Establim la localització perque surti en català
    format.locale = [[NSLocale alloc] initWithLocaleIdentifier:@"CA"];
    [lblFechaActual setText:[format stringFromDate:[self GetfechaActual]]];
    
}


// Devuelve la fecha actual
-(NSDate *) GetfechaActual
{
    
    // Establecemos el formato de fecha
    NSDateFormatter *format = [[NSDateFormatter alloc] init];
    [format setDateFormat:@"MMM dd, yyyy"];
    
    NSDate *fechaActual = [[NSDate alloc] init];
    
    return fechaActual;
    
}

// Navegació gestió despeses
- (IBAction)btnGestioDespeses:(id)sender {
    
    
    ClScrSelTrimestres *selTrimestreView = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewSelTrimestre"];
    // Establim l'id de la scr
    selTrimestreView.id_scr = @1;
    [self.navigationController pushViewController:selTrimestreView animated:YES];

}


// Navegació gestió Factures
- (IBAction)btnGestioFactures:(id)sender
{
    
    ClScrSelTrimestres *selTrimestresView = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewSelTrimestre"];
    
    // Establim l'id de la scr
    selTrimestresView.id_scr = @2;
    [self.navigationController pushViewController:selTrimestresView animated:YES];
    
}
// Navegació gestió Trajectes
- (IBAction)btnGestioTrajectes:(id)sender {
    
    ClScrSelTrimestres *selTrimestresView = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewSelTrimestre"];
    
    // Establim l'id de la scr
    selTrimestresView.id_scr = @3;
    [self.navigationController pushViewController:selTrimestresView animated:YES];
    
}




- (void)mergeiCloudChanges:(NSNotification*)note forContext:(NSManagedObjectContext*)moc {
    [moc mergeChangesFromContextDidSaveNotification:note];
    
    NSNotification* refreshNotification = [NSNotification notificationWithName:@"RefreshAllViews" object:self  userInfo:[note userInfo]];
    
    [[NSNotificationCenter defaultCenter] postNotification:refreshNotification];
}


@end
