//
//  ClScrNouImportFixe.m
//  TaxControl
//
//  Created by Javier Cava García on 14/10/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//

#import "ClScrNouImportFixe.h"
#import "SubCategoria.h"
#import "Categoria.h"
#import "ClComunes.h"
#import "ImportFixe.h"

@interface ClScrNouImportFixe ()
{
    ClComunes *funcComunes;
}
@end

@implementation ClScrNouImportFixe


// Array de SubCategories
@synthesize SubcategoriesArray;

// Control Core data
@synthesize managedObjectContext;
// Stepper Categoria
@synthesize stepCategoria;
@synthesize txtCategoria;
@synthesize txtSubcategoria;
@synthesize txtImport;
@synthesize switchActiu;
@synthesize ImportfixeEdit;
@synthesize edicio;


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    @try {
        // Establim el fons
        self.view.backgroundColor = [[UIColor alloc] initWithPatternImage:[UIImage       imageNamed:@"Background.png"]];
        // Intanciem comunes
        funcComunes = [ClComunes alloc];
        // Obtenim les dades necessaries per la gestió del Coredata
        managedObjectContext = [funcComunes get_mngObj:managedObjectContext];
        
        // Si estem en mode edicio carreguem dades
        if ( [edicio  isEqual: @1] )
        {
            
            
            // Recuperem dades
            // Recuperem la categoria
            Categoria *lCategoria = (Categoria *) ImportfixeEdit.subcategoria.categoria;
            txtCategoria.text = lCategoria.txt;
            // Recuperem la subcategoria
            SubCategoria *lSubcategoria = ( SubCategoria *) ImportfixeEdit.subcategoria;
            txtSubcategoria.text  = lSubcategoria.txt;
            // Recuperem l'import
            NSNumber *importFixe = ImportfixeEdit.importfixe;
            // Convertim a String
            txtImport.text = [NSString stringWithFormat:@"%.2f", [importFixe doubleValue]];
            [txtImport resignFirstResponder];
            // Marquem l'actiu del paràmetre
            switchActiu.on = [ImportfixeEdit.actiu boolValue];
            
        }
        else{
            // Carreguem totes les subcategories
            NSMutableArray *mutableFetchResults  = [funcComunes setSubCategories:managedObjectContext];
            [self setSubcategoriesArray:mutableFetchResults];
            mutableFetchResults = nil;
            
        }
        // Configuren el stepper de categories
        [self configura_step_categoria];
        
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}


// Configura step subcategories
-(void)configura_step_categoria
{
    [self.stepCategoria setStepValue: 1];
    [self.stepCategoria setMinimumValue:0];
    if ( SubcategoriesArray == nil)
    {
        [self.stepCategoria setMaximumValue:0];
    } else [self.stepCategoria setMaximumValue:[SubcategoriesArray count]-1];
    // Inicialitzem el text de la categoria
    if ( [txtSubcategoria text].length == 0)
    {
        NSUInteger iniValSubCat = 0;
        [self setvalors_txt:&iniValSubCat];
    }
}



// Estableix el valor de la subcategoria en funció de l'index d'entrada
// i l'array de categories
-(void)setvalors_txt:(NSUInteger *)index
{
    
    SubCategoria *lSubcategoria  = (SubCategoria *)[SubcategoriesArray   objectAtIndex:  *index];
    if ( lSubcategoria == nil)
    {
        txtSubcategoria.text = nil;
    } else
    {
        txtCategoria.text    = lSubcategoria.categoria.txt;
        txtSubcategoria.text = lSubcategoria.txt;
    }
}




- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


// Grabació Nova Subcategoria
- (IBAction)btnSave:(UIButton *)sender
{
    
    
    NSError *error = nil;
    @try {
        
        // Unicament grabem si s'han introduit les dades adequades
        if ( [txtSubcategoria text].length == 0 )
        {
            [funcComunes msg_pantalla: @"Indiqui una Subcategoria"];
        }else if ( [txtCategoria text].length == 0 )
        {
            [funcComunes msg_pantalla: @"Indiqui una Categoria"];
        }
        else if ( [txtImport text].length == 0 )
        {
            [funcComunes msg_pantalla: @"Indiqui un Import"];
        }
        else
        {
            
            if ( [edicio  isEqual: @1] )
            {
                [ImportfixeEdit setImportfixe:[NSNumber numberWithDouble:txtImport.text.doubleValue]];
                [ImportfixeEdit setActiu:[NSNumber numberWithBool:switchActiu.isOn]];
                
                
            }
            else
            {
                
                // Guardar dades
                ImportFixe *lImport = [NSEntityDescription
                                       insertNewObjectForEntityForName:@"ImportFixe"
                                       inManagedObjectContext:managedObjectContext];
                
                SubCategoria *lSubCategoria = (SubCategoria *) [SubcategoriesArray objectAtIndex:self.stepCategoria.value];
                lImport.subcategoria = lSubCategoria;
                [lImport setImportfixe:[NSNumber numberWithDouble:txtImport.text.doubleValue]];
                [lImport setActiu:[NSNumber numberWithBool:switchActiu.isOn]];
            }
            // Save
            if (![managedObjectContext save:&error]) {
                // Handle the error.
                [funcComunes msg_pantalla: @"Error al gravar el paràmetre!"];
            }else
            {
                //Mostrem misstatge
                [funcComunes msg_pantalla:@"Paràmetre gravat correctament"];
            }
            
        }
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}




// Canvi de valor a step categoria
- (IBAction)stepCategoriaChangeValue:(UIStepper *)sender {
    
    NSUInteger stepvalue = [sender value];
    if ( ( stepvalue <= [SubcategoriesArray count]-1 ))
    {
       [self setvalors_txt:&stepvalue];
       [self configura_step_categoria];
    }
    
}





// Ocultar teclat
-(IBAction) txtDoneEditing : (id) sender{
    [sender resignFirstResponder];
}

@end
