//
//  ClScrNouKmFixos.m
//  TaxControl
//
//  Created by Javier Cava García on 15/10/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//

#import "ClScrNouKmFixos.h"
#import "TipusDIVA.h"
#import "ClComunes.h"


@interface ClScrNouKmFixos ()

@end

@implementation ClScrNouKmFixos
{
    ClComunes *funcComunes;
}

@synthesize txtKm;
@synthesize managedObjectContext;
@synthesize swichtActiu;
@synthesize kmArray;
@synthesize txtPreuxkm;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    @try {
        // Establim el fons
        self.view.backgroundColor = [[UIColor alloc] initWithPatternImage:[UIImage       imageNamed:@"Background.png"]];
        // Do any additional setup after loading the view.
        // Intanciem comunes
        funcComunes = [ClComunes alloc];
        // Obtenim les dades necessaries per la gestió del Coredata
        managedObjectContext = [funcComunes get_mngObj:managedObjectContext];
        // Carreguem les dades que hi ha
        NSMutableArray *mutableFetchResults = [funcComunes set_quilometres:managedObjectContext];
        [self setKmArray:mutableFetchResults];
        if (kmArray != nil)
        {
            Quilometre *lkm = (Quilometre *) [kmArray objectAtIndex:0];
            NSString *strkm = [NSString stringWithFormat:@"%.2f", [lkm.km doubleValue]];
            txtKm.text = strkm;
            swichtActiu.on = [lkm.actiu boolValue];
            NSString *strPreuxkm = [NSString stringWithFormat:@"%.2f", [lkm.preu doubleValue]];
            txtPreuxkm.text = strPreuxkm;
            
        }
        
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


// Grabació Nova Categoria
- (IBAction)btnSave:(UIButton *)sender
{
    
    
    NSError *error = nil;
    @try {
        // Guardar
        if ( kmArray == nil)
        {
            Quilometre *lkm = [NSEntityDescription
                               insertNewObjectForEntityForName:@"Quilometre"
                               inManagedObjectContext:managedObjectContext];
            [lkm setKm:[NSNumber numberWithDouble:txtKm.text.doubleValue]];
            [lkm setActiu:[NSNumber numberWithBool:swichtActiu.isOn]];
            [lkm setPreu:[NSNumber numberWithDouble:txtPreuxkm.text.doubleValue]];
        }
        else
        {
            
            Quilometre *lkm = (Quilometre *) [kmArray objectAtIndex:0];
            [lkm setKm:[NSNumber numberWithDouble:txtKm.text.doubleValue]];
            [lkm setActiu:[NSNumber numberWithBool:swichtActiu.isOn]];
            [lkm setPreu:[NSNumber numberWithDouble:txtPreuxkm.text.doubleValue]];
            
        }
        // Set de la categoria al persitent store
        if (![managedObjectContext save:&error]) {
            // Handle the error.
            [funcComunes msg_pantalla:@"Error al gravar la configuració"];
        } else
        {
            //Mostrem misstatge
            [funcComunes msg_pantalla:@"Configuració gravada correctament!"];
            // Carreguem les dades que hi ha
            NSMutableArray *mutableFetchResults = [funcComunes set_quilometres:managedObjectContext];
            [self setKmArray:mutableFetchResults];
        }
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}



// Ocultar teclat
-(IBAction) txtDoneEditing : (id) sender{
    [sender resignFirstResponder];
}

@end
