//
//  ClScrNouTipusDIVA.m
//  TaxControl
//
//  Created by Javier Cava García on 15/10/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//

#import "ClScrNouTipusDIVA.h"
#import "TipusDIVA.h"
#import "ClComunes.h"

@interface ClScrNouTipusDIVA ()

@end

@implementation ClScrNouTipusDIVA
{
    ClComunes *funcComunes;
}

@synthesize txt;
@synthesize percentatge;
@synthesize managedObjectContext;
@synthesize TipusIvaEdit;
@synthesize edicio;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    @try {
        // Establim el fons
        self.view.backgroundColor = [[UIColor alloc] initWithPatternImage:[UIImage       imageNamed:@"Background.png"]];
        // Do any additional setup after loading the view.
        // Intanciem comunes
        funcComunes = [ClComunes alloc];
        // Obtenim les dades necessaries per la gestió del Coredata
        managedObjectContext = [funcComunes get_mngObj:managedObjectContext];
        // Si estem en mode edicio carreguem la categoria
        if ( [edicio  isEqual: @1] )
        {
            txt.text         = TipusIvaEdit.txt;
            percentatge.text = [TipusIvaEdit.percent stringValue];
        }
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


// Grabació Nova Categoria
- (IBAction)btnSave:(UIButton *)sender
{
    NSError *error = nil;
    @try {

        // Unicament grabem si s'ha introduit el texte de la categoria
        if ( [txt text].length == 0 || [percentatge text].length == 0)
        {
            [funcComunes msg_pantalla:@"Indiqui els valors del nou tipus d'IVA"];
        }else
        {
            
            
            if ( [edicio  isEqual: @1] )
            {
                [TipusIvaEdit setTxt:txt.text];
                [TipusIvaEdit setPercent:[NSNumber numberWithDouble:percentatge.text.doubleValue]];
            }
            else
            {
                // Chequejem que el tipud d'IVA no existeixi
                TipusDIVA *lTipusIVA = [funcComunes get_tipusiva_by_txt:txt.text:managedObjectContext];
                
                if ( lTipusIVA != nil)
                {
                    // El tipus d'IVA ja existeix, no deixem grabar
                    [funcComunes msg_pantalla:@"Ya existeix aquest tipus d'IVA!"];
                    return;
                }
                
                
                TipusDIVA *lTipus = [NSEntityDescription
                                     insertNewObjectForEntityForName:@"TipusDIVA"
                                     inManagedObjectContext:managedObjectContext];
                
                [lTipus setTxt:[txt text]];
                [lTipus setPercent:[NSNumber numberWithDouble:percentatge.text.doubleValue]];
                //Netejem el text
                txt.text = nil;
                percentatge.text = nil;
            }
            // Set de la categoria al persitent store
            if (![managedObjectContext save:&error]) {
                // Handle the error.
                [funcComunes msg_pantalla:@"Error al gravar el tipus d'IVA"];
            } else
            {
                
                if ( [edicio  isEqual: @1] )
                {
                    [funcComunes msg_pantalla:@"Tipus d'IVA actualitzat correctament!"];
                    
                } else
                    //Mostrem misstatge
                    [funcComunes msg_pantalla:@"Tipus d'IVA creat correctament!"];
                
            }
        }
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
    
}




// Ocultar teclat
-(IBAction) txtDoneEditing : (id) sender{
    [sender resignFirstResponder];
}

@end
