//
//  ClScrNovaCategoria.m
//  TaxControl
//
//  Created by Javier Cava García on 12/10/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//

#import "ClScrNouTipusFactura.h"
#import "TipusFactura.h"
#import "ClComunes.h"

@interface ClScrNouTipusFactura ()

@end



@implementation ClScrNouTipusFactura
{
    ClComunes *funcComunes;
}

@synthesize txtTipusFactura;
@synthesize managedObjectContext;
@synthesize tipusfacturesEdit;
@synthesize TipusFacturaEdit;
@synthesize edicio;



- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    @try {
        
        // Establim el fons
        self.view.backgroundColor = [[UIColor alloc] initWithPatternImage:[UIImage       imageNamed:@"Background.png"]];
        // Intanciem comunes
        funcComunes = [ClComunes alloc];
        // Obtenim les dades necessaries per la gestió del Coredata
        managedObjectContext = [funcComunes get_mngObj:managedObjectContext];
        // Carreguem la categoria per edicio
        NSMutableArray *mutableFetchResults  =  [funcComunes setTipusFactures: managedObjectContext];
        [self setTipusfacturesEdit:mutableFetchResults];
        
        // Si estem en mode edicio carreguem la categoria
        if ( [edicio  isEqual: @1] )
        {
            txtTipusFactura.text = TipusFacturaEdit.txt;
        }
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}





- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


// Grabació Nova Categoria
- (IBAction)btnSave:(UIButton *)sender
{
    NSError *error = nil;
    @try {
        // Unicament grabem si s'ha introduit el texte de la categoria
        if ( [txtTipusFactura text].length == 0)
        {
            [funcComunes msg_pantalla:@"Indiqui un text pel tipus de factura!"];
        }else
        {
            
            
            // Guardar Categoria
            // Depene del mode insertem o editem
            if ( [edicio  isEqual: @1] )
            {
                [TipusFacturaEdit setValue: [txtTipusFactura text] forKey :@"txt"];
            }
            else
            {
                // Chequejem que el tipus de factura no existeixi
                TipusFactura *lTipusF = [funcComunes get_tipusfactura_by_txt:txtTipusFactura.text:managedObjectContext];
                
                if ( lTipusF != nil)
                {
                    // El tipus de factura  ja existeix, no deixem grabar
                    [funcComunes msg_pantalla:@"Ya existeix aquest tipus de factura!"];
                    return;
                }
                
                
                TipusFactura *lTipus = [NSEntityDescription
                                        insertNewObjectForEntityForName:@"TipusFactura"
                                        inManagedObjectContext:managedObjectContext];
                [lTipus setValue: [txtTipusFactura text] forKey :@"txt"];
                //Netejem el text
                txtTipusFactura.text = nil;
            }
            
            // Set de la categoria al persitent store
            if (![managedObjectContext save:&error]) {
                // Handle the error.
                [funcComunes msg_pantalla:@"Error al gravar el tipus de factura"];
            } else
            {
                
                //Mostrem misstatge
                if ( [edicio  isEqual: @1] )
                {
                    [funcComunes msg_pantalla: @"Tipus de factura actualitzada correctament!"];
                    
                }
                else
                {
                    [funcComunes msg_pantalla:@"Tipus de factura creada correctament!"];
                }
            }
        }
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}



// Ocultar teclat
-(IBAction) txtDoneEditing : (id) sender{
    [sender resignFirstResponder];
}


@end
