//
//  ClScrNovaCategoria.m
//  TaxControl
//
//  Created by Javier Cava García on 12/10/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//

#import "ClScrNovaCategoria.h"
#import "Categoria.h"
#import "ClComunes.h"

@interface ClScrNovaCategoria ()

@end



@implementation ClScrNovaCategoria
{
    ClComunes *funcComunes;
}

@synthesize txtCategoria;
@synthesize managedObjectContext;
@synthesize categoriesEdit;
@synthesize CategoriaEdit;
@synthesize edicio;



- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    @try {
        // Establim el fons
        self.view.backgroundColor = [[UIColor alloc] initWithPatternImage:[UIImage       imageNamed:@"Background.png"]];
        // Intanciem comunes
        funcComunes = [ClComunes alloc];
        // Obtenim les dades necessaries per la gestió del Coredata
        managedObjectContext = [funcComunes get_mngObj:managedObjectContext];
        // Carreguem la categoria per edicio
        NSMutableArray *mutableFetchResults  =  [funcComunes setCategories:managedObjectContext];
        [self setCategoriesEdit:mutableFetchResults];
        
        // Si estem en mode edicio carreguem la categoria
        if ( [edicio  isEqual: @1] )
        {
            // Recuperem la categoria segons l'ID
            txtCategoria.text = CategoriaEdit.txt;
        }
        
        [txtCategoria resignFirstResponder];
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}





- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


// Grabació Nova Categoria
- (IBAction)btnSave:(UIButton *)sender
{
    
    @try {
        Categoria *lCat = (Categoria *)[NSEntityDescription alloc];
        // Unicament grabem si s'ha introduit el texte de la categoria
        if ( [txtCategoria text].length == 0)
        {
            [funcComunes msg_pantalla:@"Indiqui un text per la Categoria!"];
        }else
        {
            //Obtenim l'ultim ID insertat
            //NSNumber *lnewID = [self GetLastIDCategoria];
            NSError *error = nil;
            // Guardar Categoria
            // Depene del mode insertem o editem
            if ( [edicio  isEqual: @1] )
            {
                
                CategoriaEdit.txt = txtCategoria.text;
            }
            else
            {
                // Chequejem que la categoria no existeixi
                lCat = [funcComunes get_categoria_by_txt:txtCategoria.text :managedObjectContext];
                
                if ( lCat != nil)
                {
                    // La Categoria ja existeix, no deixem grabar
                    [funcComunes msg_pantalla:@"Ya existeix aquesta categoria!"];
                    return;
                }
                
                lCat = [NSEntityDescription
                        insertNewObjectForEntityForName:@"Categoria"
                        inManagedObjectContext:managedObjectContext];
                [lCat setValue: [txtCategoria text] forKey :@"txt"];
                
            }
            
            // Set de la categoria al persitent store
            if (![managedObjectContext save:&error]) {
                // Handle the error.
                [funcComunes msg_pantalla:@"Error al gravar la Categoria"];
            } else
            {
                
                //Mostrem misstatge
                if ( [edicio  isEqual: @1] )
                {
                    [funcComunes msg_pantalla: @"Categoria actualitzada correctament!"];
                    
                }
                else
                {
                    //Netejem el text
                    txtCategoria.text = nil;
                    [funcComunes msg_pantalla:@"Categoria creada correctament!"];
                }
            }
        }
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }

}





// Ocultar teclat
-(IBAction) txtDoneEditing : (id) sender{
    [sender resignFirstResponder];
}

@end
