//
//  ClScrParamImportFixe.m
//  TaxControl
//
//  Created by Javier Cava García on 14/10/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//

#import "ClScrParamImportFixe.h"
#import "ClComunes.h"
#import "ImportFixe.h"
#import "ClScrNouImportFixe.h"


@interface ClScrParamImportFixe ()

@end

@implementation ClScrParamImportFixe
{
    ClComunes *funcComunes;
}

// Array de parametres d'import fixe
@synthesize ParametresImportFixeArray;
// Core data
@synthesize managedObjectContext;
// Taula
@synthesize tblParamImportsFixes;
// Array de Categories
@synthesize CategoriesArray;
// Array de Subcategories
@synthesize SubCategoriesArray;


- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

// Carreguem dades cada vegada que es mostra el tableView
-(void)viewWillAppear:(BOOL)animated
{
    // Carreguem els parametress fixos
    @try {
        NSMutableArray *mutableFetchResults = [funcComunes set_parametres_import_fixe :managedObjectContext];
        [self setParametresImportFixeArray:mutableFetchResults];
        [tblParamImportsFixes reloadData];
        
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}



- (void)viewDidLoad
{
    [super viewDidLoad];
    @try {
        // Uncomment the following line to preserve selection between presentations.
        //self.clearsSelectionOnViewWillAppear = NO;
        // Intanciem comunes
        funcComunes = [ClComunes alloc];
        // Obtenim les dades necessaries per la gestió del Coredata
        managedObjectContext = [funcComunes get_mngObj:managedObjectContext];
        // Gestió de gestos per edició
        UITapGestureRecognizer *tapEdit = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handletapEdit:)];
        // Nombre de taps de editar
        tapEdit.numberOfTapsRequired = 2;
        // Gestos
        // Afegim el gestor de "gestos" al tableview
        [tblParamImportsFixes addGestureRecognizer:tapEdit];
        // Carreguem les categories
        NSMutableArray *mutableFetchResults  = [funcComunes setCategories:managedObjectContext];
        [self setCategoriesArray:mutableFetchResults];
        // Carreguem les subcategories
        mutableFetchResults  = [funcComunes setSubCategories:managedObjectContext];
        [self setSubCategoriesArray:mutableFetchResults];
        
        
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
    
}


// Capturador gestos
-(IBAction)handletapEdit:(UITapGestureRecognizer *)cell
{
    @try {
        CGPoint tapLocation = [cell locationInView:self.tblParamImportsFixes];
        NSIndexPath *indexPath = [self.tblParamImportsFixes indexPathForRowAtPoint:tapLocation];
        if (indexPath) {
            // Cridem la pantalla de nou import fixe pero en mode edicio
            ClScrNouImportFixe  *editImportView = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewImportfixe"];
            // Activem el mode d'edicio
            editImportView.edicio = @1;
            // Obtenim el id a editar
            ImportFixe *lImport  = (ImportFixe *)[ParametresImportFixeArray  objectAtIndex: indexPath.row];
            editImportView.ImportfixeEdit = lImport;
            editImportView.navigationItem.prompt = @"Edició Import";
            // Cridem la pantalla
            [self.navigationController pushViewController:editImportView animated:YES];
        }
        
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}




- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    return [ParametresImportFixeArray count];
    
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];

    
    
    // Configure the cell...
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:@"Cell"];
    }
    ImportFixe *lParametres  = (ImportFixe *)[ParametresImportFixeArray  objectAtIndex: indexPath.row];
    // La Cell mostrarà Categoria/Subcategoria al Label 1
    // Retorna el text de la categoria per id
    Categoria *lCategoria = (Categoria *)lParametres.subcategoria.categoria;
    SubCategoria *lSubcategoria = (SubCategoria *) lParametres.subcategoria;
    NSString *txtCat    = lCategoria.txt;
    NSString *txtSubCat = lSubcategoria.txt;
    // Obtenin el label
    UILabel  *txtLabel = (UILabel *)[cell viewWithTag:1];
    // Actualitzem el text
    NSString *txtConcat = [txtCat stringByAppendingString:@" / "];
    txtLabel.text = [txtConcat  stringByAppendingString:txtSubCat];
    // Formatejem l'import
    NSNumber *importFixe = lParametres.importfixe;
    // Actualitzaem el text
    UILabel  *txtDetail = (UILabel *)[cell viewWithTag:2];
    // Convertim a String
    NSString *strImport = [NSString stringWithFormat:@"%.2f €", [importFixe doubleValue]];
    txtDetail.text = strImport;
    // Marquem l'actiu del paràmetre
    UISwitch *lactiu = (UISwitch *)[cell viewWithTag:3];
    lactiu.on = [lParametres.actiu boolValue];
    
    
    return cell;
}



// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    @try {
        if (editingStyle == UITableViewCellEditingStyleDelete) {
            // Elimina les dades del Core Data
            ImportFixe  *lImport  = (ImportFixe *)[ParametresImportFixeArray  objectAtIndex: indexPath.row];
            [managedObjectContext deleteObject:lImport];
            // Elimina l'entrada de l'array
            [ParametresImportFixeArray removeObjectAtIndex:indexPath.row];
            // Elimina la fila del tableview
            [tableView deleteRowsAtIndexPaths:@[indexPath] withRowAnimation:UITableViewRowAnimationFade];
            [tblParamImportsFixes reloadData];
        }
        else if (editingStyle == UITableViewCellEditingStyleInsert) {
            // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
        }
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}


// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
   
    // Return NO if you do not want the specified item to be editable.
    return YES;
    
}



@end
