//
//  ClScrParametres.m
//  TaxControl
//
//  Created by Javier Cava García on 12/10/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//

#import "ClScrParametres.h"
#import "ClScrParamImportFixe.h"
#import "ClScrNouKmFixos.h"
#import "CLScrMail.h"
#import "ClComunes.h"



@interface ClScrParametres ()

@end


@implementation ClScrParametres
{
    ClComunes *funcComunes;
}


// Array de parametres, són fixos
@synthesize parametresArray;
// Core data
@synthesize managedObjectContext;

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

// Carreguem dades cada vegada que es mostra el tableView
-(void)viewWillAppear:(BOOL)animated
{
    // Carreguem les opcions
    @try {
        parametresArray = [[NSMutableArray alloc] initWithObjects:@"Imports fixes", @"Km [Trajectes]",@"Mail exportació",nil];
        [_tblParametres reloadData];
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}


- (void)viewDidLoad
{
    [super viewDidLoad];
    @try {
        // Intanciem comunes
        funcComunes = [ClComunes alloc];
        // Obtenim les dades necessaries per la gestió del Coredata
        managedObjectContext = [funcComunes get_mngObj:managedObjectContext];
        // Gestió de gestos per navegar
        UITapGestureRecognizer *tapNav = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handletapNav:)];
        // Nombre de taps per navegar
        tapNav.numberOfTapsRequired = 1;
        // Afegim el gestor de "gestos" al tableview
        [_tblParametres addGestureRecognizer:tapNav];
        
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}



-(IBAction)handletapNav:(UITapGestureRecognizer *)cell
{
    @try {
        
        CGPoint tapLocation = [cell locationInView:self.tblParametres];
        NSIndexPath *indexPath = [self.tblParametres indexPathForRowAtPoint:tapLocation];
        if (indexPath) {
            switch (indexPath.row) {
                case 0: // Import Fixe
                {
                    ClScrParamImportFixe *importFixeView = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewParamImportFixes"];
                    [self.navigationController pushViewController:importFixeView animated:YES];
                    break;
                }
                case 1: // Km
                {
                    ClScrNouKmFixos *importKmFixos = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewQuilometres"];
                    [self.navigationController pushViewController:importKmFixos animated:YES];
                    break;
                }
                    
                case 2: // Mail
                {
                    CLScrMail *mail = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewMail"];
                    [self.navigationController pushViewController:mail animated:YES];
                    break;
                }
                    
                default:
                    break;
            }
        }
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    return [parametresArray count];
    
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
  
    
    // Configure the cell...
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:@"Cell"];
    }
    // Establim el text de la Cell
    [cell.textLabel setText:[parametresArray objectAtIndex:indexPath.row]];
    return cell;
}

// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
    
}


// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{

}


// Liberamos memoria
-(void)viewWillDisappear:(BOOL)animated
{
   
}


@end
