//
//  ClScrSelTrimestres.m
//  TaxControl
//
//  Created by Javier Cava García on 14/10/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//



#import "ClComunes.h"
#import "ClScrSelTrimestres.h"
#import "ClScrGestioDespeses.h"
#import "ClScrGestioFactures.h"
#import "ClScrGestioTrajectes.h"




@interface ClScrSelTrimestres ()

@end

@implementation ClScrSelTrimestres
{
    ClComunes *funcComunes;
}

// Array de Trimestres
@synthesize TrimestresArray;
// Core data
@synthesize managedObjectContext;
// Id de screen origen
@synthesize id_scr;
@synthesize tblSel;

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

// Carreguem dades cada vegada que es mostra el tableView
-(void)viewWillAppear:(BOOL)animated
{
    // Carreguem els trimestres
    @try {
        NSMutableArray *mutableFetchResults = [funcComunes set_trimestres:managedObjectContext];
        [self setTrimestresArray:mutableFetchResults];
        
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}



- (void)viewDidLoad
{
    [super viewDidLoad];
    @try {
        // Uncomment the following line to preserve selection between presentations.
        //self.clearsSelectionOnViewWillAppear = NO;
        // Intanciem comunes
        funcComunes = [ClComunes alloc];
        // Obtenim les dades necessaries per la gestió del Coredata
        managedObjectContext = [funcComunes get_mngObj:managedObjectContext];
        // Gestió de gestos per edició
        UITapGestureRecognizer *tapSel = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handletapEdit:)];
        // Nombre de taps de editar
        tapSel.numberOfTapsRequired = 1;
        // Afegim el gestor de "gestos" al tableview
        [tblSel addGestureRecognizer:tapSel];
        
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}

// Capturador gestos
-(IBAction)handletapEdit:(UITapGestureRecognizer *)cell
{
    @try {
        CGPoint tapLocation = [cell locationInView:self.tblSel];
        NSIndexPath *indexPath = [self.tblSel indexPathForRowAtPoint:tapLocation];
        if (indexPath) {
            
            // En funció de la screen d'on es crida passem a una altra
            switch (id_scr.integerValue) {
                case 1:
                {
                    ClScrGestioDespeses *GDespesesView = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewGestioDespeses"];
                    // Establim les dates inici i final del trimestre seleccionat
                    Trimestre *lTrimestre = (Trimestre *)[TrimestresArray objectAtIndex:indexPath.row];
                    GDespesesView.iniDate = lTrimestre.datini;
                    GDespesesView.fiDate  = lTrimestre.datfin;
                    [self.navigationController pushViewController:GDespesesView animated:YES];
                    break;
                }
                case 2:
                {
                    ClScrGestioFactures *GFacturesView = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewGestioFactures"];
                    // Establim les dates inici i final del trimestre seleccionat
                    Trimestre *lTrimestre = (Trimestre *)[TrimestresArray objectAtIndex:indexPath.row];
                    GFacturesView.iniDate = lTrimestre.datini;
                    GFacturesView.fiDate  = lTrimestre.datfin;
                    [self.navigationController pushViewController:GFacturesView animated:YES];
                    break;
                }
                case 3:
                {
                    ClScrGestioTrajectes *GTrajectesView = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewGestioTrajectes"];
                    // Establim les dates inici i final del trimestre seleccionat
                    Trimestre *lTrimestre = (Trimestre *)[TrimestresArray objectAtIndex:indexPath.row];
                    GTrajectesView.iniDate = lTrimestre.datini;
                    GTrajectesView.fiDate  = lTrimestre.datfin;
                    [self.navigationController pushViewController:GTrajectesView animated:YES];
                    break;
                }
                    
                default:
                    break;
            }
            
        }
        
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    return [TrimestresArray count];
    
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init] ;
    [dateFormat setDateFormat:@"dd/MM/yyyy"];
    
    
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
    
    
    // Configure the cell...
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:@"Cell"];
    }
    Trimestre *lTrimestres  = (Trimestre *)[TrimestresArray  objectAtIndex: indexPath.row];
    // Obtenim el text de la categoria
    NSString *txtCabTrimestre = [lTrimestres txt];
    // Establim el text de la Cell
    UILabel *txtLabel = (UILabel *)[cell viewWithTag:1];
    txtLabel.text = txtCabTrimestre;
    
    // Establim el detall de la cell Inici: DD/MM/YYYY Fi:DD/MM/YYYY
    UILabel  *txtIniciTrimestre = (UILabel *)[cell viewWithTag:2];
    UILabel  *txtFiTrimestre    = (UILabel *)[cell viewWithTag:3];
    
    txtIniciTrimestre.text = [dateFormat stringFromDate:[lTrimestres datini]];
    txtFiTrimestre.text    = [dateFormat stringFromDate:[lTrimestres datfin]];
    
    return cell;
}



// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
   
    // Retur  NO if you do not want the specified item to be editable.
    return YES;
    
}


@end
