//
//  ClScrTipusDIVA.m
//  TaxControl
//
//  Created by Javier Cava García on 14/10/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//

#import "ClScrTipusDIVA.h"
#import "ClComunes.h"
#import "ClScrNouTipusDIVA.h"

@interface ClScrTipusDIVA ()

@end

@implementation ClScrTipusDIVA
{
    ClComunes *funcComunes;
}

// Array de Tipus d'IVA
@synthesize TipusDIVAArray;
// Core data
@synthesize managedObjectContext;

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

// Carreguem dades cada vegada que es mostra el tableView
-(void)viewWillAppear:(BOOL)animated
{
    
    // Carreguem els tipus d'IVA
    NSMutableArray *mutableFetchResults  = [funcComunes setTipusDIVA:managedObjectContext];
    [self setTipusDIVAArray:mutableFetchResults];
    // Refresh del tableview
    [_tblTipusDIVA  reloadData];
}



- (void)viewDidLoad
{
    [super viewDidLoad];
    @try {
        // Intanciem comunes
        funcComunes = [ClComunes alloc];
        // Obtenim les dades necessaries per la gestió del Coredata
        managedObjectContext = [funcComunes get_mngObj:managedObjectContext];
        // Gestió de gestos per edició
        UITapGestureRecognizer *tapEdit = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handletapEdit:)];
        // Nombre de taps de editar
        tapEdit.numberOfTapsRequired = 2;
        // Afegim el gestor de "gestos" al tableview
        [_tblTipusDIVA addGestureRecognizer:tapEdit];
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}


// Capturador gestos
-(IBAction)handletapEdit:(UITapGestureRecognizer *)cell
{
    @try {
        CGPoint tapLocation = [cell locationInView:self.tblTipusDIVA];
        NSIndexPath *indexPath = [self.tblTipusDIVA indexPathForRowAtPoint:tapLocation];
        if (indexPath) {
            // Cridem la pantalla de nova categoria pero en mode edicio
            ClScrNouTipusDIVA *editTipusDIVA = [self.storyboard instantiateViewControllerWithIdentifier:@"ViewNouTipusDIVA"];
            // Activem el mode d'edicio
            editTipusDIVA.edicio = @1;
            // Obtenim el id de la categoria a editar
            TipusDIVA *lTipus  = (TipusDIVA *)[TipusDIVAArray  objectAtIndex: indexPath.row];
            editTipusDIVA.TipusIvaEdit = lTipus;
            editTipusDIVA.navigationItem.prompt = @"Edició Tipus d'IVA";
            // Cridem la pantalla
            [self.navigationController pushViewController:editTipusDIVA animated:YES];
        }
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    return [TipusDIVAArray count];
    
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
    // Configure the cell...
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:@"Cell"];
    }
    // Obtenim el text del tipus d'iva
    TipusDIVA *lTipusDIVA  = (TipusDIVA *)[TipusDIVAArray objectAtIndex: indexPath.row];
    // Establim el text de la Cell
    [cell.textLabel setText:[lTipusDIVA txt]];
    return cell;
}

// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
   
    // Return NO if you do not want the specified item to be editable.
    return YES;
    
}


// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSError *error;
    @try {
        if (editingStyle == UITableViewCellEditingStyleDelete) {
            // Elimina les dades del Core Data
            TipusDIVA *lTipusDIVA  = (TipusDIVA *)[TipusDIVAArray objectAtIndex: indexPath.row];
            // Abans d'eliminar, comprobem integritat referencial
            NSMutableArray *ref = [funcComunes get_references_tipIVA:lTipusDIVA :managedObjectContext];
            if ( [ref  count] > 0)
            {
                [funcComunes msg_pantalla:@"El tipus d'IVA encara s'utilitza, no es pot eliminar!"];
            }
            else
            {
                [managedObjectContext deleteObject:lTipusDIVA];
                [managedObjectContext save:&error];
                // Elimina l'entrada de l'array
                [TipusDIVAArray removeObjectAtIndex:indexPath.row];
                // Elimina la fila del tableview
                [tableView deleteRowsAtIndexPaths:@[indexPath] withRowAnimation:UITableViewRowAnimationFade];
                [_tblTipusDIVA reloadData];
            }
            
        }
        else if (editingStyle == UITableViewCellEditingStyleInsert) {
            // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
        }
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}


@end
