//
//  ClScrTrajectes.m
//  TaxControl
//
//  Created by Javier Cava García on 18/10/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//

#import "ClScrTrajectes.h"
#import "ClComunes.h"
#import "Trajecte.h"
#import "Quilometre.h"


@interface ClScrTrajectes ()

@end

@implementation ClScrTrajectes
{
    ClComunes *funcComunes;
    Quilometre *kms;
}
// Core data
@synthesize managedObjectContext;
// Variables
@synthesize datePicker;
@synthesize btngravar;

@synthesize txtDesti;
@synthesize txtOrigen;
@synthesize txtKm;

@synthesize edicio;
@synthesize TrajecteEdit;

@synthesize kmArray;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}


-(void)viewWillAppear:(BOOL)animated
{
    @try {
        // Carreguem les dades que hi ha
        NSMutableArray *mutableFetchResults = [funcComunes set_quilometres:managedObjectContext];
        [self setKmArray:mutableFetchResults];
        // Verifiquem que tinguem el preu x km, si no ho tenim no
        
        // Si estem editant
        if ( [edicio  isEqual: @1] )
        {
            // Carreguem dades
            datePicker.date = TrajecteEdit.data;
            // Deshabilitem el datepicker
            //[datePicker setUserInteractionEnabled:FALSE];
            txtOrigen.text = TrajecteEdit.origen;
            txtDesti.text  = TrajecteEdit.desti;
            txtKm.text     = [TrajecteEdit.km stringValue];
        }
        // permetrem crear trajectes
        if ( kmArray != nil)
        {
            kms = (Quilometre *) [kmArray objectAtIndex:0];
            if ( kms.preu == nil || ( [kms.preu floatValue] == 0 ) )
            {
                // Missatge
                [funcComunes msg_pantalla: @"Imposible registrar trajectes, es necessari el preu x km!"];
                // Desactivem el botó gravar
                btngravar.enabled = false;
            } else
            {
                
                btngravar.enabled = true;
                if ( [txtKm.text length] == 0 && kms.actiu.boolValue == TRUE )
                {
                    txtKm.text = [kms.km stringValue];
                }
            }
        }
        else
        {
            // Missatge
            [funcComunes msg_pantalla: @"Imposible registrar trajectes, es necessari el preu x km!"];
            // Desactivem el botó gravar
            btngravar.enabled = false;
        }
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    @try {
        // Establim el fons
        self.view.backgroundColor = [[UIColor alloc] initWithPatternImage:[UIImage  imageNamed:@"Background.png"]];
        // Do any additional setup after loading the view.
        // Intanciem comunes
        funcComunes = [ClComunes alloc];
        // Obtenim les dades necessaries per la gestió del Coredata
        managedObjectContext = [funcComunes get_mngObj:managedObjectContext];
        
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
    
}




// Ocultar teclat
-(IBAction) txtDoneEditing : (id) sender{
    [sender resignFirstResponder];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

// Gravar despeses
- (IBAction)btnSave:(id)sender {
    
    // Comprovem dades abans de gravar
    
    NSError *error = nil;
    
    @try {
        // Unicament grabem si s'han introduit les dades adequades
        if ( ( [txtKm text].length == 0 ) || ( [txtKm.text intValue] <= 0 ) )
        {
            [funcComunes msg_pantalla: @"Indiqui els quilòmetres"];
            return;
        }
        else
        {
            
            if ( [edicio  isEqual: @1])
            {
                
                [TrajecteEdit setOrigen:txtOrigen.text];
                [TrajecteEdit setDesti:txtDesti.text];
                [TrajecteEdit setKm:[NSNumber numberWithDouble:txtKm.text.doubleValue]];
                [TrajecteEdit setData:datePicker.date];
            }
            else
            {
                // Guardar dades
                Trajecte *lTrajecte  = [NSEntityDescription
                                        insertNewObjectForEntityForName:@"Trajecte"
                                        inManagedObjectContext:managedObjectContext];
                [lTrajecte setData:datePicker.date];
                [lTrajecte setOrigen:txtOrigen.text];
                [lTrajecte setDesti:txtDesti.text];
                [lTrajecte setKm:[NSNumber numberWithDouble:txtKm.text.doubleValue]];
                
            }
        }
        // Save
        if (![managedObjectContext save:&error]) {
            // Handle the error.
            [funcComunes msg_pantalla: @"Error al gravar el trajecte!"];
        }else
        {
            //Mostrem misstatge
            [funcComunes msg_pantalla:@"Trajecte gravat correctament"];
        }
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}
// Canvia origen per desti i viceversa
- (IBAction)btnIntercanvi:(id)sender {
    
    NSString *lori_tmp = [txtOrigen text];
    txtOrigen.text = txtDesti.text;
    txtDesti.text  = lori_tmp;
    
}
@end
