//
//  ClScrTrimestres.m
//  TaxControl
//
//  Created by Javier Cava García on 14/10/13.
//  Copyright (c) 2013 Javier Cava García. All rights reserved.
//

#import "ClScrTrimestres.h"
#import "ClComunes.h"


@interface ClScrTrimestres ()

@end

@implementation ClScrTrimestres
{
    ClComunes *funcComunes;
}

// Array de Trimestres
@synthesize TrimestresArray;
// Core data
@synthesize managedObjectContext;

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

// Carreguem dades cada vegada que es mostra el tableView
-(void)viewWillAppear:(BOOL)animated
{
    // Carreguem els trimestres
    @try {
        NSMutableArray *mutableFetchResults = [funcComunes set_trimestres:managedObjectContext];
        [self setTrimestresArray:mutableFetchResults];
        
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}



- (void)viewDidLoad
{
    [super viewDidLoad];
    @try {
        // Uncomment the following line to preserve selection between presentations.
        //self.clearsSelectionOnViewWillAppear = NO;
        // Intanciem comunes
        funcComunes = [ClComunes alloc];
        // Obtenim les dades necessaries per la gestió del Coredata
        managedObjectContext = [funcComunes get_mngObj:managedObjectContext];
        
    }
    @catch (NSException *exception) {
        [funcComunes msg_excepcio:exception];
    }
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    return [TrimestresArray count];
    
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
    
    
    // Configure the cell...
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:@"Cell"];
    }
    Trimestre *lTrimestre  = (Trimestre *)[TrimestresArray  objectAtIndex: indexPath.row];
    // Obtenim el text de la categoria
    NSString *txtCabTrimestre = [lTrimestre txt];
    // Establim el text de la Cell
    UILabel *txtLabel = (UILabel *)[cell viewWithTag:1];
    txtLabel.text = txtCabTrimestre;
    
    // Establim el detall de la cell Inici: DD/MM/YYYY Fi:DD/MM/YYYY
    UILabel  *txtDetail = (UILabel *)[cell viewWithTag:2];
    // Data inicial
    NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init] ;
    [dateFormat setDateFormat:@"dd/MM/YYYY"];
    NSString *dataInicial = [dateFormat stringFromDate:[lTrimestre datini]];
    // Data Final
    NSString *dataFinal = [dateFormat stringFromDate:[lTrimestre datfin]];
    // Construim el text del detail
    NSString *txtDetailDatestmp  = [@"Inici: " stringByAppendingString:dataInicial];
    NSString *txtDetailDatestmp1 = [txtDetailDatestmp  stringByAppendingString:@" / Fi: "];
    NSString *txtDetailDates     = [txtDetailDatestmp1  stringByAppendingString:dataFinal];
    txtDetail.text = txtDetailDates;
    
    return cell;
}



// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
   
    // Return NO if you do not want the specified item to be editable.
    return NO;
    
}



@end
